module ag.com.tlb.shellobjects;

import tango.sys.win32.Types;
import dwin.sys.win32.Types;
import dwin.sys.win32.Interfaces;
import dwin.sys.win32.com.Core;

enum tagCATEGORYINFO_FLAGS {
  CATINFO_NORMAL = 0x00000000,
  CATINFO_COLLAPSED = 0x00000001,
  CATINFO_HIDDEN = 0x00000002,
  CATINFO_EXPANDED = 0x00000004,
  CATINFO_NOHEADER = 0x00000008,
  CATINFO_NOTCOLLAPSIBLE = 0x00000010,
  CATINFO_NOHEADERCOUNT = 0x00000020,
}

enum tagCATSORT_FLAGS {
  CATSORT_DEFAULT = 0x00000000,
  CATSORT_NAME = 0x00000001,
}

enum tagTYPEKIND {
  TKIND_ENUM = 0x00000000,
  TKIND_RECORD = 0x00000001,
  TKIND_MODULE = 0x00000002,
  TKIND_INTERFACE = 0x00000003,
  TKIND_DISPATCH = 0x00000004,
  TKIND_COCLASS = 0x00000005,
  TKIND_ALIAS = 0x00000006,
  TKIND_UNION = 0x00000007,
  TKIND_MAX = 0x00000008,
}

enum tagDESCKIND {
  DESCKIND_NONE = 0x00000000,
  DESCKIND_FUNCDESC = 0x00000001,
  DESCKIND_VARDESC = 0x00000002,
  DESCKIND_TYPECOMP = 0x00000003,
  DESCKIND_IMPLICITAPPOBJ = 0x00000004,
  DESCKIND_MAX = 0x00000005,
}

enum tagFUNCKIND {
  FUNC_VIRTUAL = 0x00000000,
  FUNC_PUREVIRTUAL = 0x00000001,
  FUNC_NONVIRTUAL = 0x00000002,
  FUNC_STATIC = 0x00000003,
  FUNC_DISPATCH = 0x00000004,
}

enum tagINVOKEKIND {
  INVOKE_FUNC = 0x00000001,
  INVOKE_PROPERTYGET = 0x00000002,
  INVOKE_PROPERTYPUT = 0x00000004,
  INVOKE_PROPERTYPUTREF = 0x00000008,
}

enum tagCALLCONV {
  CC_FASTCALL = 0x00000000,
  CC_CDECL = 0x00000001,
  CC_MSCPASCAL = 0x00000002,
  CC_PASCAL = 0x00000002,
  CC_MACPASCAL = 0x00000003,
  CC_STDCALL = 0x00000004,
  CC_FPFASTCALL = 0x00000005,
  CC_SYSCALL = 0x00000006,
  CC_MPWCDECL = 0x00000007,
  CC_MPWPASCAL = 0x00000008,
  CC_MAX = 0x00000009,
}

enum tagVARKIND {
  VAR_PERINSTANCE = 0x00000000,
  VAR_STATIC = 0x00000001,
  VAR_CONST = 0x00000002,
  VAR_DISPATCH = 0x00000003,
}

enum tagSYSKIND {
  SYS_WIN16 = 0x00000000,
  SYS_WIN32 = 0x00000001,
  SYS_MAC = 0x00000002,
  SYS_WIN64 = 0x00000003,
}

enum tagSIGDN {
  SIGDN_NORMALDISPLAY = 0x00000000,
  SIGDN_PARENTRELATIVEPARSING = 0x80018001,
  SIGDN_DESKTOPABSOLUTEPARSING = 0x80028000,
  SIGDN_PARENTRELATIVEEDITING = 0x80031001,
  SIGDN_DESKTOPABSOLUTEEDITING = 0x8004C000,
  SIGDN_FILESYSPATH = 0x80058000,
  SIGDN_URL = 0x80068000,
  SIGDN_PARENTRELATIVEFORADDRESSBAR = 0x8007C001,
  SIGDN_PARENTRELATIVE = 0x80080001,
}

enum tagDOMNodeType {
  NODE_INVALID = 0x00000000,
  NODE_ELEMENT = 0x00000001,
  NODE_ATTRIBUTE = 0x00000002,
  NODE_TEXT = 0x00000003,
  NODE_CDATA_SECTION = 0x00000004,
  NODE_ENTITY_REFERENCE = 0x00000005,
  NODE_ENTITY = 0x00000006,
  NODE_PROCESSING_INSTRUCTION = 0x00000007,
  NODE_COMMENT = 0x00000008,
  NODE_DOCUMENT = 0x00000009,
  NODE_DOCUMENT_TYPE = 0x0000000A,
  NODE_DOCUMENT_FRAGMENT = 0x0000000B,
  NODE_NOTATION = 0x0000000C,
}

enum tagATTACHMENT_PROMPT {
  ATTACHMENT_PROMPT_NONE = 0x00000000,
  ATTACHMENT_PROMPT_SAVE = 0x00000001,
  ATTACHMENT_PROMPT_EXEC = 0x00000002,
  ATTACHMENT_PROMPT_EXEC_OR_SAVE = 0x00000003,
}

enum tagATTACHMENT_ACTION {
  ATTACHMENT_ACTION_CANCEL = 0x00000000,
  ATTACHMENT_ACTION_SAVE = 0x00000001,
  ATTACHMENT_ACTION_EXEC = 0x00000002,
}

enum _SPACTION {
  SPACTION_NONE = 0x00000000,
  SPACTION_MOVING = 0x00000001,
  SPACTION_COPYING = 0x00000002,
  SPACTION_RECYCLING = 0x00000003,
  SPACTION_APPLYINGATTRIBS = 0x00000004,
  SPACTION_DOWNLOADING = 0x00000005,
  SPACTION_SEARCHING_INTERNET = 0x00000006,
  SPACTION_CALCULATING = 0x00000007,
  SPACTION_UPLOADING = 0x00000008,
  SPACTION_SEARCHING_FILES = 0x00000009,
  SPACTION_DELETING = 0x0000000A,
  SPACTION_RENAMING = 0x0000000B,
  SPACTION_FORMATTING = 0x0000000C,
}

enum tagPDOPSTATUS {
  PDOPS_RUNNING = 0x00000001,
  PDOPS_PAUSED = 0x00000002,
  PDOPS_CANCELLED = 0x00000003,
  PDOPS_STOPPED = 0x00000004,
  PDOPS_ERRORS = 0x00000005,
}

enum tagFDE_SHAREVIOLATION_RESPONSE {
  FDESVR_DEFAULT = 0x00000000,
  FDESVR_ACCEPT = 0x00000001,
  FDESVR_REFUSE = 0x00000002,
}

enum tagFDE_OVERWRITE_RESPONSE {
  FDEOR_DEFAULT = 0x00000000,
  FDEOR_ACCEPT = 0x00000001,
  FDEOR_REFUSE = 0x00000002,
}

enum tagFDAP {
  FDAP_BOTTOM = 0x00000000,
  FDAP_TOP = 0x00000001,
}

enum tagSIATTRIBFLAGS {
  SIATTRIBFLAGS_AND = 0x00000001,
  SIATTRIBFLAGS_OR = 0x00000002,
  SIATTRIBFLAGS_APPCOMPAT = 0x00000003,
  SIATTRIBFLAGS_MASK = 0x00000003,
}

enum tagKF_CATEGORY {
  KF_CATEGORY_VIRTUAL = 0x00000001,
  KF_CATEGORY_FIXED = 0x00000002,
  KF_CATEGORY_COMMON = 0x00000003,
  KF_CATEGORY_PERUSER = 0x00000004,
}

enum tagFFFP_MODE {
  FFFP_EXACTMATCH = 0x00000000,
  FFFP_NEARESTPARENTMATCH = 0x00000001,
}

enum _tagDEF_SHARE_ID {
  DEFSHAREID_USERS = 0x00000001,
  DEFSHAREID_PUBLIC = 0x00000002,
}

enum _tagSHARE_ROLE {
  SHARE_ROLE_INVALID = 0xFFFFFFFF,
  SHARE_ROLE_READER = 0x00000000,
  SHARE_ROLE_CONTRIBUTOR = 0x00000001,
  SHARE_ROLE_CO_OWNER = 0x00000002,
  SHARE_ROLE_OWNER = 0x00000003,
  SHARE_ROLE_CUSTOM = 0x00000004,
  SHARE_ROLE_MIXED = 0x00000005,
}

enum tagASSOCIATIONTYPE {
  AT_FILEEXTENSION = 0x00000000,
  AT_URLPROTOCOL = 0x00000001,
  AT_STARTMENUCLIENT = 0x00000002,
  AT_MIMETYPE = 0x00000003,
}

enum tagASSOCIATIONLEVEL {
  AL_MACHINE = 0x00000000,
  AL_EFFECTIVE = 0x00000001,
  AL_USER = 0x00000002,
}

enum tagFOLDERLOGICALVIEWMODE {
  FLVM_UNSPECIFIED = 0xFFFFFFFF,
  FLVM_FIRST = 0x00000001,
  FLVM_DETAILS = 0x00000001,
  FLVM_TILES = 0x00000002,
  FLVM_ICONS = 0x00000003,
  FLVM_LAST = 0x00000003,
}

enum tagCONDITION_TYPE {
  CT_AND_CONDITION = 0x00000000,
  CT_OR_CONDITION = 0x00000001,
  CT_NOT_CONDITION = 0x00000002,
  CT_LEAF_CONDITION = 0x00000003,
}

enum tagCONDITION_OPERATION {
  COP_IMPLICIT = 0x00000000,
  COP_EQUAL = 0x00000001,
  COP_NOTEQUAL = 0x00000002,
  COP_LESSTHAN = 0x00000003,
  COP_GREATERTHAN = 0x00000004,
  COP_LESSTHANOREQUAL = 0x00000005,
  COP_GREATERTHANOREQUAL = 0x00000006,
  COP_VALUE_STARTSWITH = 0x00000007,
  COP_VALUE_ENDSWITH = 0x00000008,
  COP_VALUE_CONTAINS = 0x00000009,
  COP_VALUE_NOTCONTAINS = 0x0000000A,
  COP_DOSWILDCARDS = 0x0000000B,
  COP_WORD_EQUAL = 0x0000000C,
  COP_WORD_STARTSWITH = 0x0000000D,
  COP_APPLICATION_SPECIFIC = 0x0000000E,
}

enum tagCPVIEW {
  CPVIEW_CLASSIC = 0x00000000,
  CPVIEW_CATEGORY = 0x00000001,
}

union __MIDL_IWinTypes_0009 {
  int hInproc;
  int hRemote;
}

union __MIDL___MIDL_itf_ShObjIdl_0001_0141_0001 {
  wchar* pOleStr;
  uint uOffset;
  byte[260] cStr;
}

union __MIDL___MIDL_itf_ShObjIdl_0001_0148_0001 {
  byte cVal;
  ubyte bVal;
  short iVal;
  ushort uiVal;
  int lVal;
  uint ulVal;
  int intVal;
  uint uintVal;
  _LARGE_INTEGER hVal;
  _ULARGE_INTEGER uhVal;
  float fltVal;
  double dblVal;
  short boolVal;
  short _bool;
  int scode;
  long cyVal;
  double date;
  _FILETIME filetime;
  GUID* puuid;
  tagCLIPDATA* pClipData;
  wchar* bstrVal;
  tagBSTRBLOB bstrblobVal;
  tagBLOB blob;
  char* pszVal;
  wchar* pwszVal;
  IUnknown punkVal;
  IDispatch pdispVal;
  IStream pStream;
  IStorage pStorage;
  tagVersionedStream* pVersionedStream;
  wirePSAFEARRAY parray;
  tagCAC cac;
  tagCAUB caub;
  tagCAI cai;
  tagCAUI caui;
  tagCAL cal;
  tagCAUL caul;
  tagCAH cah;
  tagCAUH cauh;
  tagCAFLT caflt;
  tagCADBL cadbl;
  tagCABOOL cabool;
  tagCASCODE cascode;
  tagCACY cacy;
  tagCADATE cadate;
  tagCAFILETIME cafiletime;
  tagCACLSID cauuid;
  tagCACLIPDATA caclipdata;
  tagCABSTR cabstr;
  tagCABSTRBLOB cabstrblob;
  tagCALPSTR calpstr;
  tagCALPWSTR calpwstr;
  tagCAPROPVARIANT capropvar;
  byte* pcVal;
  ubyte* pbVal;
  short* piVal;
  ushort* puiVal;
  int* plVal;
  uint* pulVal;
  int* pintVal;
  uint* puintVal;
  float* pfltVal;
  double* pdblVal;
  short* pboolVal;
  DECIMAL* pdecVal;
  int* pscode;
  long* pcyVal;
  double* pdate;
  wchar** pbstrVal;
  IUnknown* ppunkVal;
  IDispatch* ppdispVal;
  wirePSAFEARRAY* pparray;
  tag_inner_PROPVARIANT* pvarVal;
}

union __MIDL_IOleAutomationTypes_0001 {
  _wireSAFEARR_BSTR BstrStr;
  _wireSAFEARR_UNKNOWN UnknownStr;
  _wireSAFEARR_DISPATCH DispatchStr;
  _wireSAFEARR_VARIANT VariantStr;
  _wireSAFEARR_BRECORD RecordStr;
  _wireSAFEARR_HAVEIID HaveIidStr;
  _BYTE_SIZEDARR ByteStr;
  _SHORT_SIZEDARR WordStr;
  _LONG_SIZEDARR LongStr;
  _HYPER_SIZEDARR HyperStr;
}

union __MIDL_IOleAutomationTypes_0004 {
  long llVal;
  int lVal;
  ubyte bVal;
  short iVal;
  float fltVal;
  double dblVal;
  short boolVal;
  int scode;
  long cyVal;
  double date;
  _FLAGGED_WORD_BLOB* bstrVal;
  IUnknown punkVal;
  IDispatch pdispVal;
  _wireSAFEARRAY** parray;
  _wireBRECORD* brecVal;
  ubyte* pbVal;
  short* piVal;
  int* plVal;
  long* pllVal;
  float* pfltVal;
  double* pdblVal;
  short* pboolVal;
  int* pscode;
  long* pcyVal;
  double* pdate;
  _FLAGGED_WORD_BLOB** pbstrVal;
  IUnknown* ppunkVal;
  IDispatch* ppdispVal;
  _wireSAFEARRAY*** pparray;
  _wireVARIANT** pvarVal;
  byte cVal;
  ushort uiVal;
  uint ulVal;
  ulong ullVal;
  int intVal;
  uint uintVal;
  DECIMAL decVal;
  DECIMAL* pdecVal;
  byte* pcVal;
  ushort* puiVal;
  uint* pulVal;
  ulong* pullVal;
  int* pintVal;
  uint* puintVal;
}

union __MIDL_IOleAutomationTypes_0005 {
  tagTYPEDESC* lptdesc;
  tagARRAYDESC* lpadesc;
  uint hreftype;
}

union __MIDL_IOleAutomationTypes_0006 {
  uint oInst;
  VARIANT* lpvarValue;
}

union __MIDL_IWinTypes_0001 {
  uint dwValue;
  wchar* pwszName;
}

union __MIDL_IAdviseSink_0003 {
  _userHMETAFILEPICT* hMetaFilePict;
  _userHENHMETAFILE* hHEnhMetaFile;
  _GDI_OBJECT* hGdiHandle;
  _userHGLOBAL* hGlobal;
  wchar* lpszFileName;
  _BYTE_BLOB* pstm;
  _BYTE_BLOB* pstg;
}

union __MIDL_IWinTypes_0005 {
  int hInproc;
  _remoteMETAFILEPICT* hRemote;
  long hInproc64;
}

union __MIDL_IWinTypes_0004 {
  int hInproc;
  _BYTE_BLOB* hRemote;
  long hInproc64;
}

union __MIDL_IWinTypes_0006 {
  int hInproc;
  _BYTE_BLOB* hRemote;
  long hInproc64;
}

union __MIDL_IAdviseSink_0002 {
  _userHBITMAP* hBitmap;
  _userHPALETTE* hPalette;
  _userHGLOBAL* hGeneric;
}

union __MIDL_IWinTypes_0007 {
  int hInproc;
  _userBITMAP* hRemote;
  long hInproc64;
}

union __MIDL_IWinTypes_0008 {
  int hInproc;
  tagLOGPALETTE* hRemote;
  long hInproc64;
}

union __MIDL_IWinTypes_0003 {
  int hInproc;
  _FLAGGED_BYTE_BLOB* hRemote;
  long hInproc64;
}

struct _RemotableHandle {
  int fContext;
  __MIDL_IWinTypes_0009 u;
}

struct tagBIND_OPTS2 {
  uint cbStruct;
  uint grfFlags;
  uint grfMode;
  uint dwTickCountDeadline;
  uint dwTrackFlags;
  uint dwClassContext;
  uint locale;
  _COSERVERINFO* pServerInfo;
}

struct _COSERVERINFO {
  uint dwReserved1;
  wchar* pwszName;
  _COAUTHINFO* pAuthInfo;
  uint dwReserved2;
}

struct _COAUTHINFO {
  uint dwAuthnSvc;
  uint dwAuthzSvc;
  wchar* pwszServerPrincName;
  uint dwAuthnLevel;
  uint dwImpersonationLevel;
  _COAUTHIDENTITY* pAuthIdentityData;
  uint dwCapabilities;
}

struct _COAUTHIDENTITY {
  ushort* User;
  uint UserLength;
  ushort* Domain;
  uint DomainLength;
  ushort* Password;
  uint PasswordLength;
  uint Flags;
}

struct _LARGE_INTEGER {
  long QuadPart;
}

struct _ULARGE_INTEGER {
  ulong QuadPart;
}

struct tagSTATSTG {
  wchar* pwcsName;
  uint type;
  _ULARGE_INTEGER cbSize;
  _FILETIME mtime;
  _FILETIME ctime;
  _FILETIME atime;
  uint grfMode;
  uint grfLocksSupported;
  GUID clsid;
  uint grfStateBits;
  uint reserved;
}

struct _FILETIME {
  uint dwLowDateTime;
  uint dwHighDateTime;
}

struct _BYTE_BLOB {
  uint clSize;
  ubyte* abData;
}

struct _STRRET {
  uint uType;
  __MIDL___MIDL_itf_ShObjIdl_0001_0141_0001 DUMMYUNIONNAME;
}

struct tagEXTRASEARCH {
  GUID guidSearch;
  ushort[80] wszFriendlyName;
  ushort[2084] wszUrl;
}

struct _tagpropertykey {
  GUID fmtid;
  uint pid;
}

struct _SHELLDETAILS {
  int fmt;
  int cxChar;
  _STRRET str;
}

struct _WIN32_FIND_DATAW {
  uint dwFileAttributes;
  _FILETIME ftCreationTime;
  _FILETIME ftLastAccessTime;
  _FILETIME ftLastWriteTime;
  uint nFileSizeHigh;
  uint nFileSizeLow;
  uint dwReserved0;
  uint dwReserved1;
  ushort[260] cFileName;
  ushort[14] cAlternateFileName;
}

struct tagCATEGORY_INFO {
  tagCATEGORYINFO_FLAGS cif;
  ushort[260] wszName;
}

struct tag_inner_PROPVARIANT {
  ushort vt;
  ubyte wReserved1;
  ubyte wReserved2;
  uint wReserved3;
  __MIDL___MIDL_itf_ShObjIdl_0001_0148_0001 __MIDL____MIDL_itf_ShObjIdl_0001_01480001;
}

struct tagCLIPDATA {
  uint cbSize;
  int ulClipFmt;
  ubyte* pClipData;
}

struct tagBSTRBLOB {
  uint cbSize;
  ubyte* pData;
}

struct tagBLOB {
  uint cbSize;
  ubyte* pBlobData;
}

struct tagRemSNB {
  uint ulCntStr;
  uint ulCntChar;
  ushort* rgString;
}

struct tagVersionedStream {
  GUID guidVersion;
  IStream pStream;
}

struct _wireSAFEARRAY {
  ushort cDims;
  ushort fFeatures;
  uint cbElements;
  uint cLocks;
  _wireSAFEARRAY_UNION uArrayStructs;
  tagSAFEARRAYBOUND* rgsabound;
}

struct _wireSAFEARRAY_UNION {
  uint sfType;
  __MIDL_IOleAutomationTypes_0001 u;
}

struct _wireSAFEARR_BSTR {
  uint Size;
  _FLAGGED_WORD_BLOB** aBstr;
}

struct _FLAGGED_WORD_BLOB {
  uint fFlags;
  uint clSize;
  ushort* asData;
}

struct _wireSAFEARR_UNKNOWN {
  uint Size;
  IUnknown* apUnknown;
}

struct _wireSAFEARR_DISPATCH {
  uint Size;
  IDispatch* apDispatch;
}

struct _wireSAFEARR_VARIANT {
  uint Size;
  _wireVARIANT** aVariant;
}

struct _wireVARIANT {
  uint clSize;
  uint rpcReserved;
  ushort vt;
  ushort wReserved1;
  ushort wReserved2;
  ushort wReserved3;
  __MIDL_IOleAutomationTypes_0004 __MIDL__IOleAutomationTypes0002;
}

struct _wireBRECORD {
  uint fFlags;
  uint clSize;
  IRecordInfo pRecInfo;
  ubyte* pRecord;
}

struct tagTYPEATTR {
  GUID guid;
  uint lcid;
  uint dwReserved;
  int memidConstructor;
  int memidDestructor;
  wchar* lpstrSchema;
  uint cbSizeInstance;
  tagTYPEKIND typekind;
  ushort cFuncs;
  ushort cVars;
  ushort cImplTypes;
  ushort cbSizeVft;
  ushort cbAlignment;
  ushort wTypeFlags;
  ushort wMajorVerNum;
  ushort wMinorVerNum;
  tagTYPEDESC tdescAlias;
  tagIDLDESC idldescType;
}

struct tagTYPEDESC {
  __MIDL_IOleAutomationTypes_0005 __MIDL__IOleAutomationTypes0004;
  ushort vt;
}

struct tagARRAYDESC {
  tagTYPEDESC tdescElem;
  ushort cDims;
  tagSAFEARRAYBOUND* rgbounds;
}

struct tagSAFEARRAYBOUND {
  uint cElements;
  int lLbound;
}

struct tagIDLDESC {
  ULONG_PTR dwReserved;
  ushort wIDLFlags;
}

struct tagFUNCDESC {
  int memid;
  int* lprgscode;
  tagELEMDESC* lprgelemdescParam;
  tagFUNCKIND funckind;
  tagINVOKEKIND invkind;
  tagCALLCONV callconv;
  short cParams;
  short cParamsOpt;
  short oVft;
  short cScodes;
  tagELEMDESC elemdescFunc;
  ushort wFuncFlags;
}

struct tagELEMDESC {
  tagTYPEDESC tdesc;
  tagPARAMDESC paramdesc;
}

struct tagPARAMDESC {
  tagPARAMDESCEX* pparamdescex;
  ushort wParamFlags;
}

struct tagPARAMDESCEX {
  uint cBytes;
  VARIANT varDefaultValue;
}

struct tagVARDESC {
  int memid;
  wchar* lpstrSchema;
  __MIDL_IOleAutomationTypes_0006 __MIDL__IOleAutomationTypes0005;
  tagELEMDESC elemdescVar;
  ushort wVarFlags;
  tagVARKIND varkind;
}

struct tagTLIBATTR {
  GUID guid;
  uint lcid;
  tagSYSKIND syskind;
  ushort wMajorVerNum;
  ushort wMinorVerNum;
  ushort wLibFlags;
}

struct _wireSAFEARR_BRECORD {
  uint Size;
  _wireBRECORD** aRecord;
}

struct _wireSAFEARR_HAVEIID {
  uint Size;
  IUnknown* apUnknown;
  GUID iid;
}

struct _BYTE_SIZEDARR {
  uint clSize;
  ubyte* pData;
}

struct _SHORT_SIZEDARR {
  uint clSize;
  ushort* pData;
}

struct _LONG_SIZEDARR {
  uint clSize;
  uint* pData;
}

struct _HYPER_SIZEDARR {
  uint clSize;
  long* pData;
}

struct tagCAC {
  uint cElems;
  byte* pElems;
}

struct tagCAUB {
  uint cElems;
  ubyte* pElems;
}

struct tagCAI {
  uint cElems;
  short* pElems;
}

struct tagCAUI {
  uint cElems;
  ushort* pElems;
}

struct tagCAL {
  uint cElems;
  int* pElems;
}

struct tagCAUL {
  uint cElems;
  uint* pElems;
}

struct tagCAH {
  uint cElems;
  _LARGE_INTEGER* pElems;
}

struct tagCAUH {
  uint cElems;
  _ULARGE_INTEGER* pElems;
}

struct tagCAFLT {
  uint cElems;
  float* pElems;
}

struct tagCADBL {
  uint cElems;
  double* pElems;
}

struct tagCABOOL {
  uint cElems;
  short* pElems;
}

struct tagCASCODE {
  uint cElems;
  int* pElems;
}

struct tagCACY {
  uint cElems;
  long* pElems;
}

struct tagCADATE {
  uint cElems;
  double* pElems;
}

struct tagCAFILETIME {
  uint cElems;
  _FILETIME* pElems;
}

struct tagCACLSID {
  uint cElems;
  GUID* pElems;
}

struct tagCACLIPDATA {
  uint cElems;
  tagCLIPDATA* pElems;
}

struct tagCABSTR {
  uint cElems;
  wchar** pElems;
}

struct tagCABSTRBLOB {
  uint cElems;
  tagBSTRBLOB* pElems;
}

struct tagCALPSTR {
  uint cElems;
  char** pElems;
}

struct tagCALPWSTR {
  uint cElems;
  wchar** pElems;
}

struct tagCAPROPVARIANT {
  uint cElems;
  tag_inner_PROPVARIANT* pElems;
}

struct tagFORMATETC {
  wireCLIPFORMAT cfFormat;
  tagDVTARGETDEVICE* ptd;
  uint dwAspect;
  int lindex;
  uint tymed;
}

struct _userCLIPFORMAT {
  int fContext;
  __MIDL_IWinTypes_0001 u;
}

struct tagDVTARGETDEVICE {
  uint tdSize;
  ushort tdDriverNameOffset;
  ushort tdDeviceNameOffset;
  ushort tdPortNameOffset;
  ushort tdExtDevmodeOffset;
  ubyte* tdData;
}

struct _userSTGMEDIUM {
  _STGMEDIUM_UNION __MIDL__IAdviseSink0003;
  IUnknown pUnkForRelease;
}

struct _STGMEDIUM_UNION {
  uint tymed;
  __MIDL_IAdviseSink_0003 u;
}

struct _userHMETAFILEPICT {
  int fContext;
  __MIDL_IWinTypes_0005 u;
}

struct _remoteMETAFILEPICT {
  int mm;
  int xExt;
  int yExt;
  _userHMETAFILE* hMF;
}

struct _userHMETAFILE {
  int fContext;
  __MIDL_IWinTypes_0004 u;
}

struct _userHENHMETAFILE {
  int fContext;
  __MIDL_IWinTypes_0006 u;
}

struct _GDI_OBJECT {
  uint ObjectType;
  __MIDL_IAdviseSink_0002 u;
}

struct _userHBITMAP {
  int fContext;
  __MIDL_IWinTypes_0007 u;
}

struct _userBITMAP {
  int bmType;
  int bmWidth;
  int bmHeight;
  int bmWidthBytes;
  ushort bmPlanes;
  ushort bmBitsPixel;
  uint cbSize;
  ubyte* pBuffer;
}

struct _userHPALETTE {
  int fContext;
  __MIDL_IWinTypes_0008 u;
}

struct tagLOGPALETTE {
  ushort palVersion;
  ushort palNumEntries;
  tagPALETTEENTRY* palPalEntry;
}

struct tagPALETTEENTRY {
  ubyte peRed;
  ubyte peGreen;
  ubyte peBlue;
  ubyte peFlags;
}

struct _userHGLOBAL {
  int fContext;
  __MIDL_IWinTypes_0003 u;
}

struct _FLAGGED_BYTE_BLOB {
  uint fFlags;
  uint clSize;
  ubyte* abData;
}

struct _userFLAG_STGMEDIUM {
  int ContextFlags;
  int fPassOwnership;
  _userSTGMEDIUM Stgmed;
}

struct tagSTATDATA {
  tagFORMATETC formatetc;
  uint advf;
  IAdviseSink pAdvSink;
  uint dwConnection;
}

struct _POINTL {
  int x;
  int y;
}

struct tagRECT {
  int left;
  int top;
  int right;
  int bottom;
}

struct tagFOLDERSETTINGS {
  uint ViewMode;
  uint fFlags;
}

struct tagMSG {
  wireHWND hwnd;
  uint message;
  uint wParam;
  int lParam;
  uint time;
  tagPOINT pt;
}

struct tagPOINT {
  int x;
  int y;
}

struct tagOleMenuGroupWidths {
  int[6] width;
}

struct tagDESKBANDINFO {
  uint dwMask;
  _POINTL ptMinSize;
  _POINTL ptMaxSize;
  _POINTL ptIntegral;
  _POINTL ptActual;
  ushort[256] wszTitle;
  uint dwModeFlags;
  uint crBkgnd;
}

struct tagBANDSITEINFO {
  uint dwMask;
  uint dwState;
  uint dwStyle;
}

struct _COMDLG_FILTERSPEC {
  wchar* pszName;
  wchar* pszSpec;
}

struct tagKNOWNFOLDER_DEFINITION {
  tagKF_CATEGORY category;
  wchar* pszName;
  wchar* pszDescription;
  GUID fidParent;
  wchar* pszRelativePath;
  wchar* pszParsingName;
  wchar* pszToolTip;
  wchar* pszLocalizedName;
  wchar* pszIcon;
  wchar* pszSecurity;
  uint dwAttributes;
  uint kfdFlags;
  GUID ftidType;
}

struct tagSORTCOLUMN {
  _tagpropertykey propkey;
  int direction;
}

alias _RemotableHandle* wireHWND;

alias LPITEMIDLIST wirePIDL;
//alias _BYTE_BLOB* wirePIDL;

alias int LONG_PTR;

alias tagRemSNB* wireSNB;

alias _wireSAFEARRAY** wirePSAFEARRAY;

alias uint ULONG_PTR;

//alias uint DWORD;

alias _RemotableHandle* wireHICON;

alias _userCLIPFORMAT* wireCLIPFORMAT;

alias _userSTGMEDIUM* wireSTGMEDIUM;

alias _userFLAG_STGMEDIUM* wireFLAG_STGMEDIUM;

alias _userSTGMEDIUM* wireASYNC_STGMEDIUM;

alias tagDOMNodeType DOMNodeType;

alias _RemotableHandle* wireHMENU;

alias _userHGLOBAL* wireHGLOBAL;

alias uint UINT_PTR;

alias _userHBITMAP* wireHBITMAP;

interface IShellFolder2 : IShellFolder {
  static Guid IID = { 0x93f2f68c, 0x1d1b, 0x11d3, 0xa3, 0x0e, 0x00, 0xc0, 0x4f, 0x79, 0xab, 0xd1 };
  int GetDefaultSearchGUID(out GUID pguid);
  int EnumSearches(out IEnumExtraSearch ppenum);
  int GetDefaultColumn(uint dwRes, out uint pSort, out uint pDisplay);
  int GetDefaultColumnState(uint iColumn, out uint pcsFlags);
  int GetDetailsEx(wirePIDL pidl, _tagpropertykey* pscid, out VARIANT pv);
  int GetDetailsOf(wirePIDL pidl, uint iColumn, out _SHELLDETAILS psd);
  int MapColumnToSCID(uint iColumn, out _tagpropertykey pscid);
}

interface IShellFolder : IUnknown {
  static Guid IID = { 0x000214e6, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int ParseDisplayName(wireHWND hwnd, IBindCtx pbc, wchar* pszDisplayName, ref uint pchEaten, out wirePIDL ppidl, ref uint pdwAttributes);
  int EnumObjects(wireHWND hwnd, uint grfFlags, out IEnumIDList ppenumIDList);
  int BindToObject(wirePIDL pidl, IBindCtx pbc, ref GUID riid, void* ppv);
  int BindToStorage(wirePIDL pidl, IBindCtx pbc, ref GUID riid, void* ppv);
  int CompareIDs(LONG_PTR lParam, wirePIDL pidl1, wirePIDL pidl2);
  int CreateViewObject(wireHWND hwndOwner, ref GUID riid, void* ppv);
  int GetAttributesOf(uint cidl, wirePIDL* apidl, ref uint rgfInOut);
  int GetUIObjectOf(wireHWND hwndOwner, uint cidl, wirePIDL* apidl, ref GUID riid, ref uint rgfReserved, void* ppv);
  int GetDisplayNameOf(wirePIDL pidl, uint uFlags, out _STRRET pName);
  int SetNameOf(wireHWND hwnd, wirePIDL pidl, wchar* pszName, uint uFlags, out wirePIDL ppidlOut);
}

interface IBindCtx : IUnknown {
  static Guid IID = { 0x0000000e, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RegisterObjectBound(IUnknown punk);
  int RevokeObjectBound(IUnknown punk);
  int ReleaseBoundObjects();
  int RemoteSetBindOptions(tagBIND_OPTS2* pbindopts);
  int RemoteGetBindOptions(ref tagBIND_OPTS2 pbindopts);
  int GetRunningObjectTable(out IRunningObjectTable pprot);
  int RegisterObjectParam(wchar* pszKey, IUnknown punk);
  int GetObjectParam(wchar* pszKey, out IUnknown ppunk);
  int EnumObjectParam(out IEnumString ppenum);
  int RevokeObjectParam(wchar* pszKey);
}

interface IRunningObjectTable : IUnknown {
  static Guid IID = { 0x00000010, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int Register(uint grfFlags, IUnknown punkObject, IMoniker pmkObjectName, out uint pdwRegister);
  int Revoke(uint dwRegister);
  int IsRunning(IMoniker pmkObjectName);
  int GetObject(IMoniker pmkObjectName, out IUnknown ppunkObject);
  int NoteChangeTime(uint dwRegister, _FILETIME* pFileTime);
  int GetTimeOfLastChange(IMoniker pmkObjectName, out _FILETIME pFileTime);
  int EnumRunning(out IEnumMoniker ppenumMoniker);
}

interface IMoniker : IPersistStream {
  static Guid IID = { 0x0000000f, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteBindToObject(IBindCtx pbc, IMoniker pmkToLeft, ref GUID riidResult, out IUnknown ppvResult);
  int RemoteBindToStorage(IBindCtx pbc, IMoniker pmkToLeft, ref GUID riid, out IUnknown ppvObj);
  int Reduce(IBindCtx pbc, uint dwReduceHowFar, ref IMoniker ppmkToLeft, out IMoniker ppmkReduced);
  int ComposeWith(IMoniker pmkRight, int fOnlyIfNotGeneric, out IMoniker ppmkComposite);
  int Enum(int fForward, out IEnumMoniker ppenumMoniker);
  int IsEqual(IMoniker pmkOtherMoniker);
  int Hash(out uint pdwHash);
  int IsRunning(IBindCtx pbc, IMoniker pmkToLeft, IMoniker pmkNewlyRunning);
  int GetTimeOfLastChange(IBindCtx pbc, IMoniker pmkToLeft, out _FILETIME pFileTime);
  int Inverse(out IMoniker ppmk);
  int CommonPrefixWith(IMoniker pmkOther, out IMoniker ppmkPrefix);
  int RelativePathTo(IMoniker pmkOther, out IMoniker ppmkRelPath);
  int GetDisplayName(IBindCtx pbc, IMoniker pmkToLeft, out wchar* ppszDisplayName);
  int ParseDisplayName(IBindCtx pbc, IMoniker pmkToLeft, wchar* pszDisplayName, out uint pchEaten, out IMoniker ppmkOut);
  int IsSystemMoniker(out uint pdwMksys);
}

interface IPersistStream : IPersist {
  static Guid IID = { 0x00000109, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int IsDirty();
  int Load(IStream pstm);
  int Save(IStream pstm, int fClearDirty);
  int GetSizeMax(out _ULARGE_INTEGER pcbSize);
}

interface IPersist : IUnknown {
  static Guid IID = { 0x0000010c, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int GetClassID(out GUID pClassID);
}

/*interface IStream : ISequentialStream {
  static Guid IID = { 0x0000000c, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteSeek(_LARGE_INTEGER dlibMove, uint dwOrigin, out _ULARGE_INTEGER plibNewPosition);
  int SetSize(_ULARGE_INTEGER libNewSize);
  int RemoteCopyTo(IStream pstm, _ULARGE_INTEGER cb, out _ULARGE_INTEGER pcbRead, out _ULARGE_INTEGER pcbWritten);
  int Commit(uint grfCommitFlags);
  int Revert();
  int LockRegion(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, uint dwLockType);
  int UnlockRegion(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, uint dwLockType);
  int Stat(out tagSTATSTG pstatstg, uint grfStatFlag);
  int Clone(out IStream ppstm);
}
*/
interface ISequentialStream : IUnknown {
  static Guid IID = { 0x0c733a30, 0x2a1c, 0x11ce, 0xad, 0xe5, 0x00, 0xaa, 0x00, 0x44, 0x77, 0x3d };
  int RemoteRead(out ubyte pv, uint cb, out uint pcbRead);
  int RemoteWrite(ubyte* pv, uint cb, out uint pcbWritten);
}

interface IEnumMoniker : IUnknown {
  static Guid IID = { 0x00000102, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteNext(uint celt, out IMoniker rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumMoniker ppenum);
}

interface IEnumString : IUnknown {
  static Guid IID = { 0x00000101, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteNext(uint celt, out wchar* rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumString ppenum);
}

interface IEnumIDList : IUnknown {
  static Guid IID = { 0x000214f2, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteNext(uint celt, out wirePIDL rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumIDList ppenum);
}

interface IEnumExtraSearch : IUnknown {
  static Guid IID = { 0x0e700be1, 0x9db6, 0x11d1, 0xa1, 0xce, 0x00, 0xc0, 0x4f, 0xd7, 0x5d, 0x13 };
  int Next(uint celt, out tagEXTRASEARCH rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumExtraSearch ppenum);
}

interface IShellLinkW : IUnknown {
  static Guid IID = { 0x000214f9, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int GetPath(out wchar* pszFile, int cch, ref _WIN32_FIND_DATAW pfd, uint fFlags);
  int GetIDList(out wirePIDL ppidl);
  int SetIDList(wirePIDL pidl);
  int GetDescription(out wchar* pszName, int cch);
  int SetDescription(wchar* pszName);
  int GetWorkingDirectory(out wchar* pszDir, int cch);
  int SetWorkingDirectory(wchar* pszDir);
  int GetArguments(out wchar* pszArgs, int cch);
  int SetArguments(wchar* pszArgs);
  int GetHotkey(out ushort pwHotkey);
  int SetHotkey(ushort wHotkey);
  int GetShowCmd(out int piShowCmd);
  int SetShowCmd(int iShowCmd);
  int GetIconLocation(out wchar* pszIconPath, int cch, out int piIcon);
  int SetIconLocation(wchar* pszIconPath, int iIcon);
  int SetRelativePath(wchar* pszPathRel, uint dwReserved);
  int Resolve(wireHWND hwnd, uint fFlags);
  int SetPath(wchar* pszFile);
}

interface IQueryCancelAutoPlay : IUnknown {
  static Guid IID = { 0xddefe873, 0x6997, 0x4e68, 0xbe, 0x26, 0x39, 0xb6, 0x33, 0xad, 0xbe, 0x12 };
  int AllowAutoPlay(wchar* pszPath, uint dwContentType, wchar* pszLabel, uint dwSerialNumber);
}

interface ICategorizer : IUnknown {
  static Guid IID = { 0xa3b14589, 0x9174, 0x49a8, 0x89, 0xa3, 0x06, 0xa1, 0xae, 0x2b, 0x9b, 0xa7 };
  int GetDescription(out wchar* pszDesc, uint cch);
  int GetCategory(uint cidl, wirePIDL* apidl, out uint rgCategoryIds);
  int GetCategoryInfo(uint dwCategoryId, out tagCATEGORY_INFO pci);
  int CompareCategory(tagCATSORT_FLAGS csfFlags, uint dwCategoryId1, uint dwCategoryId2);
}

interface IPersistFile : IPersist {
  static Guid IID = { 0x0000010b, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int IsDirty();
  int Load(wchar* pszFileName, uint dwMode);
  int Save(wchar* pszFileName, int fRemember);
  int SaveCompleted(wchar* pszFileName);
  int GetCurFile(out wchar* ppszFileName);
}

interface IPropertyUI : IUnknown {
  static Guid IID = { 0x757a7d9f, 0x919a, 0x4118, 0x99, 0xd7, 0xdb, 0xb2, 0x08, 0xc8, 0xcc, 0x66 };
  int ParsePropertyName(wchar* pszName, out GUID pfmtid, out uint ppid, ref uint pchEaten);
  int GetCannonicalName(ref GUID fmtid, uint pid, out wchar* pwszText, uint cchText);
  int GetDisplayName(ref GUID fmtid, uint pid, uint Flags, out wchar* pwszText, uint cchText);
  int GetPropertyDescription(ref GUID fmtid, uint pid, out wchar* pwszText, uint cchText);
  int GetDefaultWidth(ref GUID fmtid, uint pid, out uint pcxChars);
  int GetFlags(ref GUID fmtid, uint pid, out uint pflags);
  int FormatForDisplay(ref GUID fmtid, uint pid, tag_inner_PROPVARIANT* ppropvar, uint puiff, out wchar* pwszText, uint cchText);
  int GetHelpInfo(ref GUID fmtid, uint pid, out wchar* pwszHelpFile, uint cch, out uint puHelpID);
}

/*interface IStorage : IUnknown {
  static Guid IID = { 0x0000000b, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int CreateStream(wchar* pwcsName, uint grfMode, uint reserved1, uint reserved2, out IStream ppstm);
  int RemoteOpenStream(wchar* pwcsName, uint cbReserved1, ubyte* reserved1, uint grfMode, uint reserved2, out IStream ppstm);
  int CreateStorage(wchar* pwcsName, uint grfMode, uint reserved1, uint reserved2, out IStorage ppstg);
  int OpenStorage(wchar* pwcsName, IStorage pstgPriority, uint grfMode, wireSNB snbExclude, uint reserved, out IStorage ppstg);
  int RemoteCopyTo(uint ciidExclude, ref GUID rgiidExclude, wireSNB snbExclude, IStorage pstgDest);
  int MoveElementTo(wchar* pwcsName, IStorage pstgDest, wchar* pwcsNewName, uint grfFlags);
  int Commit(uint grfCommitFlags);
  int Revert();
  int RemoteEnumElements(uint reserved1, uint cbReserved2, ubyte* reserved2, uint reserved3, out IEnumSTATSTG ppenum);
  int DestroyElement(wchar* pwcsName);
  int RenameElement(wchar* pwcsOldName, wchar* pwcsNewName);
  int SetElementTimes(wchar* pwcsName, _FILETIME* pctime, _FILETIME* patime, _FILETIME* pmtime);
  int SetClass(ref GUID clsid);
  int SetStateBits(uint grfStateBits, uint grfMask);
  int Stat(out tagSTATSTG pstatstg, uint grfStatFlag);
}
*/
interface IEnumSTATSTG : IUnknown {
  static Guid IID = { 0x0000000d, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteNext(uint celt, out tagSTATSTG rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumSTATSTG ppenum);
}

interface IRecordInfo : IUnknown {
  static Guid IID = { 0x0000002f, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RecordInit(void* pvNew);
  int RecordClear(void* pvExisting);
  int RecordCopy(void* pvExisting, void* pvNew);
  int GetGuid(out GUID pguid);
  int GetName(out wchar* pbstrName);
  int GetSize(out uint pcbSize);
  int GetTypeInfo(out ITypeInfo ppTypeInfo);
  int GetField(void* pvData, wchar* szFieldName, out VARIANT pvarField);
  int GetFieldNoCopy(void* pvData, wchar* szFieldName, out VARIANT pvarField, void* ppvDataCArray);
  int PutField(uint wFlags, void* pvData, wchar* szFieldName, VARIANT* pvarField);
  int PutFieldNoCopy(uint wFlags, void* pvData, wchar* szFieldName, VARIANT* pvarField);
  int GetFieldNames(ref uint pcNames, out wchar* rgBstrNames);
  int IsMatchingType(IRecordInfo pRecordInfo);
  void* RecordCreate();
  int RecordCreateCopy(void* pvSource, void* ppvDest);
  int RecordDestroy(void* pvRecord);
}

interface ITypeInfo : IUnknown {
  static Guid IID = { 0x00020401, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteGetTypeAttr(out tagTYPEATTR ppTypeAttr, out DWORD pDummy);
  int GetTypeComp(out ITypeComp ppTComp);
  int RemoteGetFuncDesc(uint index, out tagFUNCDESC ppFuncDesc, out DWORD pDummy);
  int RemoteGetVarDesc(uint index, out tagVARDESC ppVarDesc, out DWORD pDummy);
  int RemoteGetNames(int memid, out wchar* rgBstrNames, uint cMaxNames, out uint pcNames);
  int GetRefTypeOfImplType(uint index, out uint pRefType);
  int GetImplTypeFlags(uint index, out int pImplTypeFlags);
  int LocalGetIDsOfNames();
  int LocalInvoke();
  int RemoteGetDocumentation(int memid, uint refPtrFlags, out wchar* pbstrName, out wchar* pBstrDocString, out uint pdwHelpContext, out wchar* pBstrHelpFile);
  int RemoteGetDllEntry(int memid, tagINVOKEKIND invkind, uint refPtrFlags, out wchar* pBstrDllName, out wchar* pbstrName, out ushort pwOrdinal);
  int GetRefTypeInfo(uint hreftype, out ITypeInfo ppTInfo);
  int LocalAddressOfMember();
  int RemoteCreateInstance(ref GUID riid, out IUnknown ppvObj);
  int GetMops(int memid, out wchar* pBstrMops);
  int RemoteGetContainingTypeLib(out ITypeLib ppTLib, out uint pIndex);
  int LocalReleaseTypeAttr();
  int LocalReleaseFuncDesc();
  int LocalReleaseVarDesc();
}

interface ITypeComp : IUnknown {
  static Guid IID = { 0x00020403, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteBind(wchar* szName, uint lHashVal, ushort wFlags, out ITypeInfo ppTInfo, out tagDESCKIND pDescKind, out tagFUNCDESC ppFuncDesc, out tagVARDESC ppVarDesc, out ITypeComp ppTypeComp, out DWORD pDummy);
  int RemoteBindType(wchar* szName, uint lHashVal, out ITypeInfo ppTInfo);
}

interface ITypeLib : IUnknown {
  static Guid IID = { 0x00020402, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteGetTypeInfoCount(out uint pcTInfo);
  int GetTypeInfo(uint index, out ITypeInfo ppTInfo);
  int GetTypeInfoType(uint index, out tagTYPEKIND pTKind);
  int GetTypeInfoOfGuid(ref GUID guid, out ITypeInfo ppTInfo);
  int RemoteGetLibAttr(out tagTLIBATTR ppTLibAttr, out DWORD pDummy);
  int GetTypeComp(out ITypeComp ppTComp);
  int RemoteGetDocumentation(int index, uint refPtrFlags, out wchar* pbstrName, out wchar* pBstrDocString, out uint pdwHelpContext, out wchar* pBstrHelpFile);
  int RemoteIsName(wchar* szNameBuf, uint lHashVal, out int pfName, out wchar* pBstrLibName);
  int RemoteFindName(wchar* szNameBuf, uint lHashVal, out ITypeInfo ppTInfo, out int rgMemId, ref ushort pcFound, out wchar* pBstrLibName);
  int LocalReleaseTLibAttr();
}

interface IUserNotification : IUnknown {
  static Guid IID = { 0xba9711ba, 0x5893, 0x4787, 0xa7, 0xe1, 0x41, 0x27, 0x71, 0x51, 0x55, 0x0b };
  int SetBalloonInfo(wchar* pszTitle, wchar* pszText, uint dwInfoFlags);
  int SetBalloonRetry(uint dwShowTime, uint dwInterval, uint cRetryCount);
  int SetIconInfo(wireHICON hIcon, wchar* pszToolTip);
  int Show(IQueryContinue pqc, uint dwContinuePollInterval);
  int PlaySound(wchar* pszSoundName);
}

interface IQueryContinue : IUnknown {
  static Guid IID = { 0x7307055c, 0xb24a, 0x486b, 0x9f, 0x25, 0x16, 0x3e, 0x59, 0x7a, 0x28, 0xa9 };
  int QueryContinue();
}

interface ICDBurn : IUnknown {
  static Guid IID = { 0x3d73a659, 0xe5d0, 0x4d42, 0xaf, 0xc0, 0x51, 0x21, 0xba, 0x42, 0x5c, 0x8d };
  int GetRecorderDriveLetter(out wchar* pszDrive, uint cch);
  int Burn(wireHWND hwnd);
  int HasRecordableDrive(out int pfHasRecorder);
}

interface ITaskbarList2 : ITaskbarList {
  static Guid IID = { 0x602d4995, 0xb13a, 0x429b, 0xa6, 0x6e, 0x19, 0x35, 0xe4, 0x4f, 0x43, 0x17 };
  int MarkFullscreenWindow(wireHWND hwnd, int fFullscreen);
}

interface ITaskbarList : IUnknown {
  static Guid IID = { 0x56fdf342, 0xfd6d, 0x11d0, 0x95, 0x8a, 0x00, 0x60, 0x97, 0xc9, 0xa0, 0x90 };
  int HrInit();
  int AddTab(wireHWND hwnd);
  int DeleteTab(wireHWND hwnd);
  int ActivateTab(wireHWND hwnd);
  int SetActiveAlt(wireHWND hwnd);
}

interface IStartMenuPinnedList : IUnknown {
  static Guid IID = { 0x4cd19ada, 0x25a5, 0x4a32, 0xb3, 0xb7, 0x34, 0x7b, 0xee, 0x5b, 0xe3, 0x6b };
  int RemoveFromList(IShellItem pitem);
}

interface IShellItem : IUnknown {
  static Guid IID = { 0x43826d1e, 0xe718, 0x42ee, 0xbc, 0x55, 0xa1, 0xe2, 0x61, 0xc3, 0x7b, 0xfe };
  int BindToHandler(IBindCtx pbc, ref GUID bhid, ref GUID riid, void* ppv);
  int GetParent(out IShellItem ppsi);
  int GetDisplayName(tagSIGDN sigdnName, out wchar* ppszName);
  int GetAttributes(uint sfgaoMask, out uint psfgaoAttribs);
  int Compare(IShellItem psi, uint hint, out int piOrder);
}

interface IWebWizardExtension : IWizardExtension {
  static Guid IID = { 0x0e6b3f66, 0x98d1, 0x48c0, 0xa2, 0x22, 0xfb, 0xde, 0x74, 0xe2, 0xfb, 0xc5 };
  int SetInitialURL(wchar* pszURL);
  int SetErrorURL(wchar* pszErrorURL);
}

interface IWizardExtension : IUnknown {
  static Guid IID = { 0xc02ea696, 0x86cc, 0x491e, 0x9b, 0x23, 0x74, 0x39, 0x4a, 0x04, 0x44, 0xa8 };
  int AddPages(void* aPages, uint cPages, out uint pnPagesAdded);
  int GetFirstPage(void* phpage);
  int GetLastPage(void* phpage);
}

interface IDropTarget : IUnknown {
  static Guid IID = { 0x00000122, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int DragEnter(IDataObject pDataObj, uint grfKeyState, _POINTL pt, ref uint pdwEffect);
  int DragOver(uint grfKeyState, _POINTL pt, ref uint pdwEffect);
  int DragLeave();
  int Drop(IDataObject pDataObj, uint grfKeyState, _POINTL pt, ref uint pdwEffect);
}

/* Defined elsewhere in DWIN
  interface IDataObject : IUnknown {
  static Guid IID = { 0x0000010e, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteGetData(tagFORMATETC* pformatetcIn, out wireSTGMEDIUM pRemoteMedium);
  int RemoteGetDataHere(tagFORMATETC* pformatetc, ref wireSTGMEDIUM pRemoteMedium);
  int QueryGetData(tagFORMATETC* pformatetc);
  int GetCanonicalFormatEtc(tagFORMATETC* pformatectIn, out tagFORMATETC pformatetcOut);
  int RemoteSetData(tagFORMATETC* pformatetc, wireFLAG_STGMEDIUM* pmedium, int fRelease);
  int EnumFormatEtc(uint dwDirection, out IEnumFORMATETC ppenumFormatEtc);
  int DAdvise(tagFORMATETC* pformatetc, uint advf, IAdviseSink pAdvSink, out uint pdwConnection);
  int DUnadvise(uint dwConnection);
  int EnumDAdvise(out IEnumSTATDATA ppenumAdvise);
}
*/

interface IEnumFORMATETC : IUnknown {
  static Guid IID = { 0x00000103, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteNext(uint celt, out tagFORMATETC rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumFORMATETC ppenum);
}

interface IAdviseSink : IUnknown {
  static Guid IID = { 0x0000010f, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteOnDataChange(tagFORMATETC* pformatetc, wireASYNC_STGMEDIUM* pStgmed);
  int RemoteOnViewChange(uint dwAspect, int lindex);
  int RemoteOnRename(IMoniker pmk);
  int RemoteOnSave();
  int RemoteOnClose();
}

interface IEnumSTATDATA : IUnknown {
  static Guid IID = { 0x00000105, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int RemoteNext(uint celt, out tagSTATDATA rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumSTATDATA ppenum);
}

interface IPublishingWizard : IWizardExtension {
  static Guid IID = { 0xaa9198bb, 0xccec, 0x472d, 0xbe, 0xed, 0x19, 0xa4, 0xf6, 0x73, 0x3f, 0x7a };
  int Initialize(IDataObject pdo, uint dwOptions, wchar* pszServiceScope);
  int GetTransferManifest(out int phrFromTransfer, out IXMLDOMDocument pdocManifest);
}

interface IXMLDOMDocument : IXMLDOMNode {
  static Guid IID = { 0x2933bf81, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_doctype(out IXMLDOMDocumentType documentType);
  int get_implementation(out IXMLDOMImplementation impl);
  int get_documentElement(out IXMLDOMElement DOMElement);
  int setref_documentElement(IXMLDOMElement DOMElement);
  int createElement(wchar* tagName, out IXMLDOMElement element);
  int createDocumentFragment(out IXMLDOMDocumentFragment docFrag);
  int createTextNode(wchar* data, out IXMLDOMText text);
  int createComment(wchar* data, out IXMLDOMComment comment);
  int createCDATASection(wchar* data, out IXMLDOMCDATASection cdata);
  int createProcessingInstruction(wchar* target, wchar* data, out IXMLDOMProcessingInstruction pi);
  int createAttribute(wchar* name, out IXMLDOMAttribute attribute);
  int createEntityReference(wchar* name, out IXMLDOMEntityReference entityRef);
  int getElementsByTagName(wchar* tagName, out IXMLDOMNodeList resultList);
  int createNode(VARIANT type, wchar* name, wchar* namespaceURI, out IXMLDOMNode node);
  int nodeFromID(wchar* idString, out IXMLDOMNode node);
  int Load(VARIANT xmlSource, out short isSuccessful);
  int get_readyState(out int value);
  int get_parseError(out IXMLDOMParseError errorObj);
  int get_url(out wchar* urlString);
  int get_async(out short isAsync);
  int set_async(short isAsync);
  int abort();
  int loadXML(wchar* bstrXML, out short isSuccessful);
  int Save(VARIANT desination);
  int get_validateOnParse(out short isValidating);
  int set_validateOnParse(short isValidating);
  int get_resolveExternals(out short isResolving);
  int set_resolveExternals(short isResolving);
  int get_preserveWhiteSpace(out short isPreserving);
  int set_preserveWhiteSpace(short isPreserving);
  int set_onreadystatechange(VARIANT value);
  int set_ondataavailable(VARIANT value);
  int set_ontransformnode(VARIANT value);
}

interface IXMLDOMNode : IDispatch {
  static Guid IID = { 0x2933bf80, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_nodeName(out wchar* name);
  int get_nodeValue(out VARIANT value);
  int set_nodeValue(VARIANT value);
  int get_nodeType(out DOMNodeType type);
  int get_parentNode(out IXMLDOMNode parent);
  int get_childNodes(out IXMLDOMNodeList childList);
  int get_firstChild(out IXMLDOMNode firstChild);
  int get_lastChild(out IXMLDOMNode lastChild);
  int get_previousSibling(out IXMLDOMNode previousSibling);
  int get_nextSibling(out IXMLDOMNode nextSibling);
  int get_attributes(out IXMLDOMNamedNodeMap attributeMap);
  int insertBefore(IXMLDOMNode newChild, VARIANT refChild, out IXMLDOMNode outNewChild);
  int replaceChild(IXMLDOMNode newChild, IXMLDOMNode oldChild, out IXMLDOMNode outOldChild);
  int removeChild(IXMLDOMNode childNode, out IXMLDOMNode oldChild);
  int appendChild(IXMLDOMNode newChild, out IXMLDOMNode outNewChild);
  int hasChildNodes(out short hasChild);
  int get_ownerDocument(out IXMLDOMDocument DOMDocument);
  int cloneNode(short deep, out IXMLDOMNode cloneRoot);
  int get_nodeTypeString(out wchar* nodeType);
  int get_text(out wchar* text);
  int set_text(wchar* text);
  int get_specified(out short isSpecified);
  int get_definition(out IXMLDOMNode definitionNode);
  int get_nodeTypedValue(out VARIANT typedValue);
  int set_nodeTypedValue(VARIANT typedValue);
  int get_dataType(out VARIANT dataTypeName);
  int set_dataType(wchar* dataTypeName);
  int get_xml(out wchar* xmlString);
  int transformNode(IXMLDOMNode stylesheet, out wchar* xmlString);
  int selectNodes(wchar* queryString, out IXMLDOMNodeList resultList);
  int selectSingleNode(wchar* queryString, out IXMLDOMNode resultNode);
  int get_parsed(out short isParsed);
  int get_namespaceURI(out wchar* namespaceURI);
  int get_prefix(out wchar* prefixString);
  int get_baseName(out wchar* nameString);
  int transformNodeToObject(IXMLDOMNode stylesheet, VARIANT outputObject);
}

interface IXMLDOMNodeList : IDispatch {
  static Guid IID = { 0x2933bf82, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_item(int index, out IXMLDOMNode listItem);
  int get_length(out int listLength);
  int nextNode(out IXMLDOMNode nextItem);
  int Reset();
  int get__newEnum(out IUnknown ppunk);
}

interface IXMLDOMNamedNodeMap : IDispatch {
  static Guid IID = { 0x2933bf83, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int getNamedItem(wchar* name, out IXMLDOMNode namedItem);
  int setNamedItem(IXMLDOMNode newItem, out IXMLDOMNode nameItem);
  int removeNamedItem(wchar* name, out IXMLDOMNode namedItem);
  int get_item(int index, out IXMLDOMNode listItem);
  int get_length(out int listLength);
  int getQualifiedItem(wchar* baseName, wchar* namespaceURI, out IXMLDOMNode qualifiedItem);
  int removeQualifiedItem(wchar* baseName, wchar* namespaceURI, out IXMLDOMNode qualifiedItem);
  int nextNode(out IXMLDOMNode nextItem);
  int Reset();
  int get__newEnum(out IUnknown ppunk);
}

interface IXMLDOMDocumentType : IXMLDOMNode {
  static Guid IID = { 0x2933bf8b, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_name(out wchar* rootName);
  int get_entities(out IXMLDOMNamedNodeMap entityMap);
  int get_notations(out IXMLDOMNamedNodeMap notationMap);
}

interface IXMLDOMImplementation : IDispatch {
  static Guid IID = { 0x2933bf8f, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int hasFeature(wchar* feature, wchar* versionParam, out short hasFeature);
}

interface IXMLDOMElement : IXMLDOMNode {
  static Guid IID = { 0x2933bf86, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_tagName(out wchar* tagName);
  int getAttribute(wchar* name, out VARIANT value);
  int setAttribute(wchar* name, VARIANT value);
  int removeAttribute(wchar* name);
  int getAttributeNode(wchar* name, out IXMLDOMAttribute attributeNode);
  int setAttributeNode(IXMLDOMAttribute DOMAttribute, out IXMLDOMAttribute attributeNode);
  int removeAttributeNode(IXMLDOMAttribute DOMAttribute, out IXMLDOMAttribute attributeNode);
  int getElementsByTagName(wchar* tagName, out IXMLDOMNodeList resultList);
  int normalize();
}

interface IXMLDOMAttribute : IXMLDOMNode {
  static Guid IID = { 0x2933bf85, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_name(out wchar* attributeName);
  int get_value(out VARIANT attributeValue);
  int set_value(VARIANT attributeValue);
}

interface IXMLDOMDocumentFragment : IXMLDOMNode {
  static Guid IID = { 0x3efaa413, 0x272f, 0x11d2, 0x83, 0x6f, 0x00, 0x00, 0xf8, 0x7a, 0x77, 0x82 };
}

interface IXMLDOMText : IXMLDOMCharacterData {
  static Guid IID = { 0x2933bf87, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int splitText(int offset, out IXMLDOMText rightHandTextNode);
}

interface IXMLDOMCharacterData : IXMLDOMNode {
  static Guid IID = { 0x2933bf84, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_data(out wchar* data);
  int set_data(wchar* data);
  int get_length(out int dataLength);
  int substringData(int offset, int count, out wchar* data);
  int appendData(wchar* data);
  int insertData(int offset, wchar* data);
  int deleteData(int offset, int count);
  int replaceData(int offset, int count, wchar* data);
}

interface IXMLDOMComment : IXMLDOMCharacterData {
  static Guid IID = { 0x2933bf88, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
}

interface IXMLDOMCDATASection : IXMLDOMText {
  static Guid IID = { 0x2933bf8a, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
}

interface IXMLDOMProcessingInstruction : IXMLDOMNode {
  static Guid IID = { 0x2933bf89, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
  int get_target(out wchar* name);
  int get_data(out wchar* value);
  int set_data(wchar* value);
}

interface IXMLDOMEntityReference : IXMLDOMNode {
  static Guid IID = { 0x2933bf8e, 0x7b36, 0x11d2, 0xb2, 0x0e, 0x00, 0xc0, 0x4f, 0x98, 0x3e, 0x60 };
}

interface IXMLDOMParseError : IDispatch {
  static Guid IID = { 0x3efaa426, 0x272f, 0x11d2, 0x83, 0x6f, 0x00, 0x00, 0xf8, 0x7a, 0x77, 0x82 };
  int get_errorCode(out int errorCode);
  int get_url(out wchar* urlString);
  int get_reason(out wchar* reasonString);
  int get_srcText(out wchar* sourceString);
  int get_line(out int lineNumber);
  int get_linepos(out int linePosition);
  int get_filepos(out int filePosition);
}

interface IFolderViewHost : IUnknown {
  static Guid IID = { 0x1ea58f02, 0xd55a, 0x411d, 0xb0, 0x9e, 0x9e, 0x65, 0xac, 0x21, 0x60, 0x5b };
  int Initialize(wireHWND hwndParent, IDataObject pdo, tagRECT* prc);
}

interface IExplorerBrowser : IUnknown {
  static Guid IID = { 0xdfd3b6b5, 0xc10c, 0x4be9, 0x85, 0xf6, 0xa6, 0x69, 0x69, 0xf4, 0x02, 0xf6 };
  int Initialize(wireHWND hwndParent, tagRECT* prc, tagFOLDERSETTINGS* pfs);
  int Destroy();
  int SetRect(void* phdwp, tagRECT rcBrowser);
  int SetPropertyBag(wchar* pszPropertyBag);
  int SetEmptyText(wchar* pszEmptyText);
  int SetFolderSettings(tagFOLDERSETTINGS* pfs);
  int Advise(IExplorerBrowserEvents psbe, out uint pdwCookie);
  int Unadvise(uint dwCookie);
  int SetOptions(uint dwFlag);
  int GetOptions(out uint pdwFlag);
  int BrowseToIDList(wirePIDL pidl, uint uFlags);
  int BrowseToObject(IUnknown punk, uint uFlags);
  int FillFromObject(IUnknown punk, uint dwFlags);
  int RemoveAll();
  int GetCurrentView(ref GUID riid, void* ppv);
}

interface IExplorerBrowserEvents : IUnknown {
  static Guid IID = { 0x361bbdc7, 0xe6ee, 0x4e13, 0xbe, 0x58, 0x58, 0xe2, 0x24, 0x0c, 0x81, 0x0f };
  int OnNavigationPending(wirePIDL pidlFolder);
  int OnViewCreated(IShellView psv);
  int OnNavigationComplete(wirePIDL pidlFolder);
  int OnNavigationFailed(wirePIDL pidlFolder);
}

interface IShellView : IOleWindow {
  static Guid IID = { 0x000214e3, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int TranslateAccelerator(tagMSG* pmsg);
  int EnableModeless(int fEnable);
  int UIActivate(uint uState);
  int Refresh();
  int CreateViewWindow(IShellView psvPrevious, tagFOLDERSETTINGS* pfs, IShellBrowser psb, tagRECT* prcView, out wireHWND phwnd);
  int DestroyViewWindow();
  int GetCurrentInfo(out tagFOLDERSETTINGS pfs);
  int AddPropertySheetPages(uint dwReserved, LONG_PTR pfn, LONG_PTR lParam);
  int SaveViewState();
  int SelectItem(wirePIDL pidlItem, uint uFlags);
  int GetItemObject(uint uItem, ref GUID riid, void* ppv);
}

interface IOleWindow : IUnknown {
  static Guid IID = { 0x00000114, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int GetWindow(out wireHWND phwnd);
  int ContextSensitiveHelp(int fEnterMode);
}

interface IShellBrowser : IOleWindow {
  static Guid IID = { 0x000214e2, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int InsertMenusSB(wireHMENU hmenuShared, ref tagOleMenuGroupWidths lpMenuWidths);
  int SetMenuSB(wireHMENU hmenuShared, wireHGLOBAL holemenuRes, wireHWND hwndActiveObject);
  int RemoveMenusSB(wireHMENU hmenuShared);
  int SetStatusTextSB(wchar* pszStatusText);
  int EnableModelessSB(int fEnable);
  int TranslateAcceleratorSB(tagMSG* pmsg, ushort wID);
  int BrowseObject(wirePIDL pidl, uint wFlags);
  int GetViewStateStream(uint grfMode, out IStream ppStrm);
  int GetControlWindow(uint id, out wireHWND phwnd);
  int SendControlMsg(uint id, uint uMsg, UINT_PTR wParam, LONG_PTR lParam, out LONG_PTR pret);
  int QueryActiveShellView(out IShellView ppshv);
  int OnViewWindowActive(IShellView pshv);
  int SetToolbarItems(LONG_PTR lpButtons, uint nButtons, uint uFlags);
}

interface IImageRecompress : IUnknown {
  static Guid IID = { 0x505f1513, 0x6b3e, 0x4892, 0xa2, 0x72, 0x59, 0xf8, 0x88, 0x9a, 0x4d, 0x3e };
  int RecompressImage(IShellItem psi, int cx, int cy, int iQuality, IStorage pstg, out IStream ppstrmOut);
}

interface IBandSite : IUnknown {
  static Guid IID = { 0x4cf504b0, 0xde96, 0x11d0, 0x8b, 0x3f, 0x00, 0xa0, 0xc9, 0x11, 0xe8, 0xe5 };
  int AddBand(IUnknown punk);
  int EnumBands(uint uBand, out uint pdwBandID);
  int QueryBand(uint dwBandID, out IDeskBand ppstb, out uint pdwState, out wchar* pszName, int cchName);
  int SetBandState(uint dwBandID, uint dwMask, uint dwState);
  int RemoveBand(uint dwBandID);
  int GetBandObject(uint dwBandID, ref GUID riid, void* ppv);
  int SetBandSiteInfo(tagBANDSITEINFO* pbsinfo);
  int GetBandSiteInfo(ref tagBANDSITEINFO pbsinfo);
}

interface IDeskBand : IDockingWindow {
  static Guid IID = { 0xeb0fe172, 0x1a3a, 0x11d0, 0x89, 0xb3, 0x00, 0xa0, 0xc9, 0x0a, 0x90, 0xac };
  int GetBandInfo(uint dwBandID, uint dwViewMode, ref tagDESKBANDINFO pdbi);
}

interface IDockingWindow : IOleWindow {
  static Guid IID = { 0x012dd920, 0x7b26, 0x11d0, 0x8c, 0xa9, 0x00, 0xa0, 0xc9, 0x2d, 0xbf, 0xe8 };
  int ShowDW(int fShow);
  int CloseDW(uint dwReserved);
  int ResizeBorderDW(tagRECT* prcBorder, IUnknown punkToolbarSite, int fReserved);
}

interface ITrayDeskBand : IUnknown {
  static Guid IID = { 0x6d67e846, 0x5b9c, 0x4db8, 0x9c, 0xbc, 0xdd, 0xe1, 0x2f, 0x42, 0x54, 0xf1 };
  int ShowDeskBand(ref GUID clsid);
  int HideDeskBand(ref GUID clsid);
  int IsDeskBandShown(ref GUID clsid);
  int DeskBandRegistrationChanged();
}

interface IAttachmentExecute : IUnknown {
  static Guid IID = { 0x73db1241, 0x1e85, 0x4581, 0x8e, 0x4f, 0xa8, 0x1e, 0x1d, 0x0f, 0x8c, 0x57 };
  int SetClientTitle(wchar* pszTitle);
  int SetClientGuid(ref GUID guid);
  int SetLocalPath(wchar* pszLocalPath);
  int SetFileName(wchar* pszFileName);
  int SetSource(wchar* pszSource);
  int SetReferrer(wchar* pszReferrer);
  int CheckPolicy();
  int Prompt(wireHWND hwnd, tagATTACHMENT_PROMPT Prompt, out tagATTACHMENT_ACTION paction);
  int Save();
  int Execute(wireHWND hwnd, wchar* pszVerb, void* phProcess);
  int SaveWithUI(wireHWND hwnd);
  int ClearClientState();
}

interface IShellExtInit : IUnknown {
  static Guid IID = { 0x000214e8, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  int Initialize(wirePIDL pidlFolder, IDataObject pdtobj, void* hkeyProgID);
}

interface IShellItem2 : IShellItem {
  static Guid IID = { 0x7e9fb0d3, 0x919f, 0x4307, 0xab, 0x2e, 0x9b, 0x18, 0x60, 0x31, 0x0c, 0x93 };
  int GetPropertyStore(int Flags, ref GUID riid, void* ppv);
  int GetPropertyStoreWithCreateObject(int Flags, IUnknown punkCreateObject, ref GUID riid, void* ppv);
  int GetPropertyStoreForKeys(_tagpropertykey* rgKeys, uint cKeys, int Flags, ref GUID riid, void* ppv);
  int GetPropertyDescriptionList(_tagpropertykey* keyType, ref GUID riid, void* ppv);
  int Update(IBindCtx pbc);
  int GetProperty(_tagpropertykey* key, out tag_inner_PROPVARIANT ppropvar);
  int GetCLSID(_tagpropertykey* key, out GUID pclsid);
  int GetFileTime(_tagpropertykey* key, out _FILETIME pft);
  int GetInt32(_tagpropertykey* key, out int pi);
  int GetString(_tagpropertykey* key, out wchar* ppsz);
  int GetUInt32(_tagpropertykey* key, out uint pui);
  int GetUInt64(_tagpropertykey* key, out ulong pull);
  int GetBool(_tagpropertykey* key, out int pf);
}

interface INamespaceWalk : IUnknown {
  static Guid IID = { 0x57ced8a7, 0x3f4a, 0x432c, 0x93, 0x50, 0x30, 0xf2, 0x44, 0x83, 0xf7, 0x4f };
  int Walk(IUnknown punkToWalk, uint dwFlags, int cDepth, INamespaceWalkCB pnswcb);
  int GetIDArrayResult(out uint pcItems, out wirePIDL prgpidl);
}

interface INamespaceWalkCB : IUnknown {
  static Guid IID = { 0xd92995f8, 0xcf5e, 0x4a76, 0xbf, 0x59, 0xea, 0xd3, 0x9e, 0xa2, 0xb9, 0x7e };
  int FoundItem(IShellFolder psf, wirePIDL pidl);
  int EnterFolder(IShellFolder psf, wirePIDL pidl);
  int LeaveFolder(IShellFolder psf, wirePIDL pidl);
  int InitializeProgressDialog(out wchar* ppszTitle, out wchar* ppszCancel);
}

interface IFileOperation : IUnknown {
  static Guid IID = { 0x947aab5f, 0x0a5c, 0x4c13, 0xb4, 0xd6, 0x4b, 0xf7, 0x83, 0x6f, 0xc9, 0xf8 };
  int Advise(IFileOperationProgressSink pfops, out uint pdwCookie);
  int Unadvise(uint dwCookie);
  int SetOperationFlags(uint dwOperationFlags);
  int SetProgressMessage(wchar* pszMessage);
  int SetProgressDialog(IOperationsProgressDialog popd);
  int SetProperties(IPropertyChangeArray pproparray);
  int SetOwnerWindow(wireHWND hwndParent);
  int ApplyPropertiesToItem(IShellItem psiItem);
  int ApplyPropertiesToItems(IUnknown punkItems);
  int RenameItem(IShellItem psiItem, wchar* pszNewName, IFileOperationProgressSink pfopsItem);
  int RenameItems(IUnknown punkItems, wchar* pszNewName);
  int MoveItem(IShellItem psiItem, IShellItem psiDestinationFolder, wchar* pszNewName, IFileOperationProgressSink pfopsItem);
  int MoveItems(IUnknown punkItems, IShellItem psiDestinationFolder);
  int CopyItem(IShellItem psiItem, IShellItem psiDestinationFolder, wchar* pszCopyName, IFileOperationProgressSink pfopsItem);
  int CopyItems(IUnknown punkItems, IShellItem psiDestinationFolder);
  int DeleteItem(IShellItem psiItem, IFileOperationProgressSink pfopsItem);
  int DeleteItems(IUnknown punkItems);
  int newItem(IShellItem psiDestinationFolder, uint dwFileAttributes, wchar* pszName, wchar* pszTemplateName, IFileOperationProgressSink pfopsItem);
  int PerformOperations();
  int GetAnyOperationsAborted(out int pfAnyOperationsAborted);
}

interface IFileOperationProgressSink : IUnknown {
  static Guid IID = { 0x04b0f1a7, 0x9490, 0x44bc, 0x96, 0xe1, 0x42, 0x96, 0xa3, 0x12, 0x52, 0xe2 };
  int StartOperations();
  int FinishOperations(int hrResult);
  int PreRenameItem(uint dwFlags, IShellItem psiItem, wchar* pszNewName);
  int PostRenameItem(uint dwFlags, IShellItem psiItem, wchar* pszNewName, int hrRename, IShellItem psiNewlyCreated);
  int PreMoveItem(uint dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, wchar* pszNewName);
  int PostMoveItem(uint dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, wchar* pszNewName, int hrMove, IShellItem psiNewlyCreated);
  int PreCopyItem(uint dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, wchar* pszNewName);
  int PostCopyItem(uint dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, wchar* pszNewName, int hrCopy, IShellItem psiNewlyCreated);
  int PreDeleteItem(uint dwFlags, IShellItem psiItem);
  int PostDeleteItem(uint dwFlags, IShellItem psiItem, int hrDelete, IShellItem psiNewlyCreated);
  int PreNewItem(uint dwFlags, IShellItem psiDestinationFolder, wchar* pszNewName);
  int PostNewItem(uint dwFlags, IShellItem psiDestinationFolder, wchar* pszNewName, wchar* pszTemplateName, uint dwFileAttributes, int hrNew, IShellItem psiNewItem);
  int UpdateProgress(uint iWorkTotal, uint iWorkSoFar);
  int ResetTimer();
  int PauseTimer();
  int ResumeTimer();
}

interface IOperationsProgressDialog : IUnknown {
  static Guid IID = { 0x0c9fb851, 0xe5c9, 0x43eb, 0xa3, 0x70, 0xf0, 0x67, 0x7b, 0x13, 0x87, 0x4c };
  int StartProgressDialog(wireHWND hwndParent, uint dwFlags);
  int StopProgressDialog();
  int SetOperation(_SPACTION action);
  int SetMode(uint mode);
  int UpdateProgress(ulong ullPointsCurrent, ulong ullPointsTotal, ulong ullSizeCurrent, ulong ullSizeTotal, ulong ullItemsCurrent, ulong ullItemsTotal);
  int UpdateLocations(IShellItem psiSource, IShellItem psiTarget, IShellItem psiItem);
  int ResetTimer();
  int PauseTimer();
  int ResumeTimer();
  int GetMilliseconds(out ulong pullElapsed, out ulong pullRemaining);
  int GetOperationStatus(out tagPDOPSTATUS popstatus);
}

interface IPropertyChangeArray : IUnknown {
  static Guid IID = { 0x380f5cad, 0x1b5e, 0x42f2, 0x80, 0x5d, 0x63, 0x7f, 0xd3, 0x92, 0xd3, 0x1e };
  int GetCount(out uint pcOperations);
  int GetAt(uint iIndex, ref GUID riid, void* ppv);
  int InsertAt(uint iIndex, IPropertyChange ppropChange);
  int Append(IPropertyChange ppropChange);
  int AppendOrReplace(IPropertyChange ppropChange);
  int RemoveAt(uint iIndex);
  int IsKeyInArray(_tagpropertykey* key);
}

interface IPropertyChange : IObjectWithPropertyKey {
  static Guid IID = { 0xf917bc8a, 0x1bba, 0x4478, 0xa2, 0x45, 0x1b, 0xde, 0x03, 0xeb, 0x94, 0x31 };
  int ApplyToPropVariant(tag_inner_PROPVARIANT* propvarIn, out tag_inner_PROPVARIANT ppropvarOut);
}

interface IObjectWithPropertyKey : IUnknown {
  static Guid IID = { 0xfc0ca0a7, 0xc316, 0x4fd2, 0x90, 0x31, 0x3e, 0x62, 0x8e, 0x6d, 0x4f, 0x23 };
  int SetPropertyKey(_tagpropertykey* key);
  int GetPropertyKey(out _tagpropertykey pkey);
}

interface IFileOpenDialog : IFileDialog {
  static Guid IID = { 0xd57c7288, 0xd4ad, 0x4768, 0xbe, 0x02, 0x9d, 0x96, 0x95, 0x32, 0xd9, 0x60 };
  int GetResults(out IShellItemArray ppenum);
  int GetSelectedItems(out IShellItemArray ppsai);
}

interface IFileDialog : IModalWindow {
  static Guid IID = { 0x42f85136, 0xdb7e, 0x439c, 0x85, 0xf1, 0xe4, 0x07, 0x5d, 0x13, 0x5f, 0xc8 };
  int SetFileTypes(uint cFileTypes, _COMDLG_FILTERSPEC* rgFilterSpec);
  int SetFileTypeIndex(uint iFileType);
  int GetFileTypeIndex(out uint piFileType);
  int Advise(IFileDialogEvents pfde, out uint pdwCookie);
  int Unadvise(uint dwCookie);
  int SetOptions(uint fos);
  int GetOptions(out uint pfos);
  int SetDefaultFolder(IShellItem psi);
  int SetFolder(IShellItem psi);
  int GetFolder(out IShellItem ppsi);
  int GetCurrentSelection(out IShellItem ppsi);
  int SetFileName(wchar* pszName);
  int GetFileName(out wchar* pszName);
  int SetTitle(wchar* pszTitle);
  int SetOkButtonLabel(wchar* pszText);
  int SetFileNameLabel(wchar* pszLabel);
  int GetResult(out IShellItem ppsi);
  int AddPlace(IShellItem psi, tagFDAP fdap);
  int SetDefaultExtension(wchar* pszDefaultExtension);
  int Close(int hr);
  int SetClientGuid(ref GUID guid);
  int ClearClientData();
  int SetFilter(IShellItemFilter pFilter);
}

interface IModalWindow : IUnknown {
  static Guid IID = { 0xb4db1657, 0x70d7, 0x485e, 0x8e, 0x3e, 0x6f, 0xcb, 0x5a, 0x5c, 0x18, 0x02 };
  int RemoteShow(wireHWND hwndParent);
}

interface IFileDialogEvents : IUnknown {
  static Guid IID = { 0x973510db, 0x7d7f, 0x452b, 0x89, 0x75, 0x74, 0xa8, 0x58, 0x28, 0xd3, 0x54 };
  int OnFileOk(IFileDialog pfd);
  int OnFolderChanging(IFileDialog pfd, IShellItem psiFolder);
  int OnFolderChange(IFileDialog pfd);
  int OnSelectionChange(IFileDialog pfd);
  int OnShareViolation(IFileDialog pfd, IShellItem psi, out tagFDE_SHAREVIOLATION_RESPONSE pResponse);
  int OnTypeChange(IFileDialog pfd);
  int OnOverwrite(IFileDialog pfd, IShellItem psi, out tagFDE_OVERWRITE_RESPONSE pResponse);
}

interface IShellItemFilter : IUnknown {
  static Guid IID = { 0x2659b475, 0xeeb8, 0x48b7, 0x8f, 0x07, 0xb3, 0x78, 0x81, 0x0f, 0x48, 0xcf };
  int IncludeItem(IShellItem psi);
  int GetEnumFlagsForItem(IShellItem psi, out uint pgrfFlags);
}

interface IShellItemArray : IUnknown {
  static Guid IID = { 0xb63ea76d, 0x1f85, 0x456f, 0xa1, 0x9c, 0x48, 0x15, 0x9e, 0xfa, 0x85, 0x8b };
  int BindToHandler(IBindCtx pbc, ref GUID rbhid, ref GUID riid, void* ppvOut);
  int GetPropertyStore(int Flags, ref GUID riid, void* ppv);
  int GetPropertyDescriptionList(_tagpropertykey* keyType, ref GUID riid, void* ppv);
  int GetAttributes(tagSIATTRIBFLAGS dwAttribFlags, uint sfgaoMask, out uint psfgaoAttribs);
  int GetCount(out uint pdwNumItems);
  int GetItemAt(uint dwIndex, out IShellItem ppsi);
  int EnumItems(out IEnumShellItems ppenumShellItems);
}

interface IEnumShellItems : IUnknown {
  static Guid IID = { 0x70629033, 0xe363, 0x4a28, 0xa5, 0x67, 0x0d, 0xb7, 0x80, 0x06, 0xe6, 0xd7 };
  int Next(uint celt, out IShellItem rgelt, out uint pceltFetched);
  int Skip(uint celt);
  int Reset();
  int Clone(out IEnumShellItems ppenum);
}

interface IFileSaveDialog : IFileDialog {
  static Guid IID = { 0x84bccd23, 0x5fde, 0x4cdb, 0xae, 0xa4, 0xaf, 0x64, 0xb8, 0x3d, 0x78, 0xab };
  int SetSaveAsItem(IShellItem psi);
  int SetProperties(IPropertyStore pStore);
  int SetCollectedProperties(IPropertyDescriptionList pList, int fAppendDefault);
  int GetProperties(out IPropertyStore ppStore);
  int ApplyProperties(IShellItem psi, IPropertyStore pStore, wireHWND hwnd, IFileOperationProgressSink pSink);
}

interface IPropertyStore : IUnknown {
  static Guid IID = { 0x886d8eeb, 0x8cf2, 0x4446, 0x8d, 0x02, 0xcd, 0xba, 0x1d, 0xbd, 0xcf, 0x99 };
  int GetCount(out uint cProps);
  int GetAt(uint iProp, out _tagpropertykey pkey);
  int GetValue(_tagpropertykey* key, out tag_inner_PROPVARIANT pv);
  int SetValue(_tagpropertykey* key, tag_inner_PROPVARIANT* propvar);
  int Commit();
}

interface IPropertyDescriptionList : IUnknown {
  static Guid IID = { 0x1f9fc1d0, 0xc39b, 0x4b26, 0x81, 0x7f, 0x01, 0x19, 0x67, 0xd3, 0x44, 0x0e };
  int GetCount(out uint pcElem);
  int GetAt(uint iElem, ref GUID riid, void* ppv);
}

interface IKnownFolderManager : IUnknown {
  static Guid IID = { 0x8be2d872, 0x86aa, 0x4d47, 0xb7, 0x76, 0x32, 0xcc, 0xa4, 0x0c, 0x70, 0x18 };
  int FolderIdFromCsidl(int nCsidl, out GUID pfid);
  int FolderIdToCsidl(ref GUID rfid, out int pnCsidl);
  int GetFolderIds(out GUID ppKFId, ref uint pCount);
  int GetFolder(ref GUID rfid, out IKnownFolder ppkf);
  int GetFolderByName(wchar* pszCanonicalName, out IKnownFolder ppkf);
  int RegisterFolder(ref GUID rfid, tagKNOWNFOLDER_DEFINITION* pKFD);
  int UnregisterFolder(ref GUID rfid);
  int FindFolderFromPath(wchar* pszPath, tagFFFP_MODE mode, out IKnownFolder ppkf);
  int FindFolderFromIDList(wirePIDL pidl, out IKnownFolder ppkf);
  int Redirect(ref GUID rfid, wireHWND hwnd, uint Flags, wchar* pszTargetPath, uint cFolders, ref GUID pExclusion, out wchar* ppszError);
}

interface IKnownFolder : IUnknown {
  static Guid IID = { 0x3aa7af7e, 0x9b36, 0x420c, 0xa8, 0xe3, 0xf7, 0x7d, 0x46, 0x74, 0xa4, 0x88 };
  int GetId(out GUID pkfid);
  int GetCategory(out tagKF_CATEGORY pCategory);
  int GetShellItem(uint dwFlags, ref GUID riid, void* ppv);
  int GetPath(uint dwFlags, out wchar* ppszPath);
  int SetPath(uint dwFlags, wchar* pszPath);
  int GetIDList(uint dwFlags, out wirePIDL ppidl);
  int GetFolderType(out GUID pftid);
  int GetRedirectionCapabilities(out uint pCapabilities);
  int GetFolderDefinition(out tagKNOWNFOLDER_DEFINITION pKFD);
}

interface ISharingConfigurationManager : IUnknown {
  static Guid IID = { 0xb4cd448a, 0x9c86, 0x4466, 0x92, 0x01, 0x2e, 0x62, 0x10, 0x5b, 0x87, 0xae };
  int CreateShare(_tagDEF_SHARE_ID dsid, _tagSHARE_ROLE role);
  int DeleteShare(_tagDEF_SHARE_ID dsid);
  int ShareExists(_tagDEF_SHARE_ID dsid);
  int GetSharePermissions(_tagDEF_SHARE_ID dsid, out _tagSHARE_ROLE pRole);
  int SharePrinters();
  int StopSharingPrinters();
  int ArePrintersShared();
}

interface IPreviousVersionsInfo : IUnknown {
  static Guid IID = { 0x76e54780, 0xad74, 0x48e3, 0xa6, 0x95, 0x3b, 0xa9, 0xa0, 0xaf, 0xf1, 0x0d };
  int AreSnapshotsAvailable(wchar* pszPath, int fOkToBeSlow, out int pfAvailable);
}

interface INameSpaceTreeControl : IUnknown {
  static Guid IID = { 0x028212a3, 0xb627, 0x47e9, 0x88, 0x56, 0xc1, 0x42, 0x65, 0x55, 0x4e, 0x4f };
  int Initialize(wireHWND hwndParent, tagRECT* prc, uint nsctsFlags);
  int TreeAdvise(IUnknown punk, out uint pdwCookie);
  int TreeUnadvise(uint dwCookie);
  int AppendRoot(IShellItem psiRoot, uint grfEnumFlags, uint grfRootStyle, IShellItemFilter pif);
  int InsertRoot(int iIndex, IShellItem psiRoot, uint grfEnumFlags, uint grfRootStyle, IShellItemFilter pif);
  int RemoveRoot(IShellItem psiRoot);
  int RemoveAllRoots();
  int GetRootItems(out IShellItemArray ppsiaRootItems);
  int SetItemState(IShellItem psi, uint nstcisMask, uint nstcisFlags);
  int GetItemState(IShellItem psi, uint nstcisMask, out uint pnstcisFlags);
  int GetSelectedItems(out IShellItemArray psiaItems);
  int GetItemCustomState(IShellItem psi, out int piStateNumber);
  int SetItemCustomState(IShellItem psi, int iStateNumber);
  int EnsureItemVisible(IShellItem psi);
  int SetTheme(wchar* pszTheme);
  int GetNextItem(IShellItem psi, uint nstcgi, out IShellItem ppsiNext);
  int HitTest(tagPOINT* ppt, out IShellItem ppsiOut);
  int GetItemRect(IShellItem psi, out tagRECT prect);
  int CollapseAll();
}

interface IApplicationAssociationRegistration : IUnknown {
  static Guid IID = { 0x4e530b0a, 0xe611, 0x4c77, 0xa3, 0xac, 0x90, 0x31, 0xd0, 0x22, 0x28, 0x1b };
  int QueryCurrentDefault(wchar* pszQuery, tagASSOCIATIONTYPE atQueryType, tagASSOCIATIONLEVEL alQueryLevel, out wchar* ppszAssociation);
  int QueryAppIsDefault(wchar* pszQuery, tagASSOCIATIONTYPE atQueryType, tagASSOCIATIONLEVEL alQueryLevel, wchar* pszAppRegistryName, out int pfDefault);
  int QueryAppIsDefaultAll(tagASSOCIATIONLEVEL alQueryLevel, wchar* pszAppRegistryName, out int pfDefault);
  int SetAppAsDefault(wchar* pszAppRegistryName, wchar* pszSet, tagASSOCIATIONTYPE atSetType);
  int SetAppAsDefaultAll(wchar* pszAppRegistryName);
  int ClearUserAssociations();
}

interface IApplicationAssociationRegistrationUI : IUnknown {
  static Guid IID = { 0x1f76a169, 0xf994, 0x40ac, 0x8f, 0xc8, 0x09, 0x59, 0xe8, 0x87, 0x47, 0x10 };
  int LaunchAdvancedAssociationUI(wchar* pszAppRegistryName);
}

interface ISearchFolderItemFactory : IUnknown {
  static Guid IID = { 0xa0ffbc28, 0x5482, 0x4366, 0xbe, 0x27, 0x3e, 0x81, 0xe7, 0x8e, 0x06, 0xc2 };
  int SetDisplayName(wchar* pszDisplayName);
  int SetFolderTypeID(GUID ftid);
  int SetFolderLogicalViewMode(tagFOLDERLOGICALVIEWMODE flvm);
  int SetIconSize(int iIconSize);
  int SetVisibleColumns(uint cVisibleColumns, _tagpropertykey* rgKey);
  int SetSortColumns(uint cSortColumns, tagSORTCOLUMN* rgSortColumns);
  int SetGroupColumn(_tagpropertykey* keyGroup);
  int SetStacks(uint cStackKeys, _tagpropertykey* rgStackKeys);
  int SetScope(IShellItemArray psiaScope);
  int SetCondition(ICondition pCondition);
  int GetShellItem(ref GUID riid, void* ppv);
  int GetIDList(out wirePIDL ppidl);
}

interface ICondition : IPersistStream {
  static Guid IID = { 0x0fc988d4, 0xc935, 0x4b97, 0xa9, 0x73, 0x46, 0x28, 0x2e, 0xa1, 0x75, 0xc8 };
  int GetConditionType(out tagCONDITION_TYPE pNodeType);
  int GetSubConditions(ref GUID riid, void* ppv);
  int GetComparisonInfo(out wchar* ppszPropertyName, out tagCONDITION_OPERATION pOperation, out tag_inner_PROPVARIANT pValue);
  int GetValueType(out wchar* ppszValueTypeName);
  int GetValueNormalization(out wchar* ppszNormalization);
  int GetInputTerms(out IRichChunk ppPropertyTerm, out IRichChunk ppOperationTerm, out IRichChunk ppValueTerm);
  int Clone(out ICondition ppc);
}

interface IRichChunk : IUnknown {
  static Guid IID = { 0x4fdef69c, 0xdbc9, 0x454e, 0x99, 0x10, 0xb3, 0x4f, 0x3c, 0x64, 0xb5, 0x10 };
  int GetData(out uint pFirstPos, out uint pLength, out wchar* ppsz, out tag_inner_PROPVARIANT pValue);
}

interface IOpenControlPanel : IUnknown {
  static Guid IID = { 0xd11ad862, 0x66de, 0x4df4, 0xbf, 0x6c, 0x1f, 0x56, 0x21, 0x99, 0x6a, 0xf1 };
  int Open(wchar* pszName, wchar* pszPage, IUnknown punkSite);
  int GetPath(wchar* pszName, out wchar* pszPath, uint cchPath);
  int GetCurrentView(out tagCPVIEW pView);
}

interface IComputerInfoAdvise : IUnknown {
  static Guid IID = { 0x4623bd61, 0x5603, 0x444f, 0x82, 0x4a, 0xaa, 0xeb, 0xce, 0xed, 0x93, 0xfa };
  int Advise(ISystemCPLUpdate pUpdate, out uint pdwCookie);
  int Unadvise(uint dwCookie);
}

interface ISystemCPLUpdate : IUnknown {
  static Guid IID = { 0xa8a71374, 0x80c2, 0x49e0, 0x88, 0x05, 0x85, 0x24, 0xeb, 0xc4, 0x5b, 0x07 };
  int UpdateSystemInfo(wchar* pszDescription, wchar* pszSpeed, wchar* pszMemory, uint dwNumProcessors);
  int UpdateLicensingInfo(uint dwLicensingStatus, uint dwGraceTimeRemainingMinutes, uint dwTotalGraceTimeDays, int fIsGenuine);
  int UpdateRatingsInfo(wchar* pszRatingsLink, wchar* pszRatingsText, wireHBITMAP hRatingsImage, ushort uWinCRSLevel);
  int UpdateComputerInfo();
}

abstract class ShellDesktop {
  static Guid CLSID = { 0x00021400, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  mixin CoInterfaces!(IShellFolder2);
}

abstract class ShellFSFolder {
  static Guid CLSID = { 0xf3364ba0, 0x65b9, 0x11ce, 0xa9, 0xba, 0x00, 0xaa, 0x00, 0x4a, 0xe8, 0x37 };
  mixin CoInterfaces!(IShellFolder2);
}

abstract class NetworkPlaces {
  static Guid CLSID = { 0x208d2c60, 0x3aea, 0x1069, 0xa2, 0xd7, 0x08, 0x00, 0x2b, 0x30, 0x30, 0x9d };
  mixin CoInterfaces!(IShellFolder2);
}

abstract class ShellLink {
  static Guid CLSID = { 0x00021401, 0x0000, 0x0000, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 };
  mixin CoInterfaces!(IShellLinkW);
}

abstract class QueryCancelAutoPlay {
  static Guid CLSID = { 0x331f1768, 0x05a9, 0x4ddd, 0xb8, 0x6e, 0xda, 0xe3, 0x4d, 0xdc, 0x99, 0x8a };
  mixin CoInterfaces!(IQueryCancelAutoPlay);
}

abstract class DriveSizeCategorizer {
  static Guid CLSID = { 0x94357b53, 0xca29, 0x4b78, 0x83, 0xae, 0xe8, 0xfe, 0x74, 0x09, 0x13, 0x4f };
  mixin CoInterfaces!(ICategorizer);
}

abstract class DriveTypeCategorizer {
  static Guid CLSID = { 0xb0a8f3cf, 0x4333, 0x4bab, 0x88, 0x73, 0x1c, 0xcb, 0x1c, 0xad, 0xa4, 0x8b };
  mixin CoInterfaces!(ICategorizer);
}

abstract class FreeSpaceCategorizer {
  static Guid CLSID = { 0xb5607793, 0x24ac, 0x44c7, 0x82, 0xe2, 0x83, 0x17, 0x26, 0xaa, 0x6c, 0xb7 };
  mixin CoInterfaces!(ICategorizer);
}

abstract class TimeCategorizer {
  static Guid CLSID = { 0x3bb4118f, 0xddfd, 0x4d30, 0xa3, 0x48, 0x9f, 0xb5, 0xd6, 0xbf, 0x1a, 0xfe };
  mixin CoInterfaces!(ICategorizer);
}

abstract class SizeCategorizer {
  static Guid CLSID = { 0x55d7b852, 0xf6d1, 0x42f2, 0xaa, 0x75, 0x87, 0x28, 0xa1, 0xb2, 0xd2, 0x64 };
  mixin CoInterfaces!(ICategorizer);
}

abstract class AlphabeticalCategorizer {
  static Guid CLSID = { 0x3c2654c6, 0x7372, 0x4f6b, 0xb3, 0x10, 0x55, 0xd6, 0x12, 0x8f, 0x49, 0xd2 };
  mixin CoInterfaces!(ICategorizer);
}

abstract class MergedCategorizer {
  static Guid CLSID = { 0x8e827c11, 0x33e7, 0x4bc1, 0xb2, 0x42, 0x8c, 0xd9, 0xa1, 0xc2, 0xb3, 0x04 };
  mixin CoInterfaces!(ICategorizer);
}

abstract class ImageProperties {
  static Guid CLSID = { 0x7ab770c7, 0x0e23, 0x4d7a, 0x8a, 0xa2, 0x19, 0xbf, 0xad, 0x47, 0x98, 0x29 };
  mixin CoInterfaces!(IPersistFile);
}

abstract class PropertiesUI {
  static Guid CLSID = { 0xd912f8cf, 0x0396, 0x4915, 0x88, 0x4e, 0xfb, 0x42, 0x5d, 0x32, 0x94, 0x3b };
  mixin CoInterfaces!(IPropertyUI);
}

abstract class UserNotification {
  static Guid CLSID = { 0x0010890e, 0x8789, 0x413c, 0xad, 0xbc, 0x48, 0xf5, 0xb5, 0x11, 0xb3, 0xaf };
  mixin CoInterfaces!(IUserNotification);
}

abstract class CDBurn {
  static Guid CLSID = { 0xfbeb8a05, 0xbeee, 0x4442, 0x80, 0x4e, 0x40, 0x9d, 0x6c, 0x45, 0x15, 0xe9 };
  mixin CoInterfaces!(ICDBurn);
}

abstract class TaskbarList {
  static Guid CLSID = { 0x56fdf344, 0xfd6d, 0x11d0, 0x95, 0x8a, 0x00, 0x60, 0x97, 0xc9, 0xa0, 0x90 };
  mixin CoInterfaces!(ITaskbarList2);
}

abstract class StartMenuPin {
  static Guid CLSID = { 0xa2a9545d, 0xa0c2, 0x42b4, 0x97, 0x08, 0xa0, 0xb2, 0xba, 0xdd, 0x77, 0xc8 };
  mixin CoInterfaces!(IStartMenuPinnedList);
}

abstract class WebWizardHost {
  static Guid CLSID = { 0xc827f149, 0x55c1, 0x4d28, 0x93, 0x5e, 0x57, 0xe4, 0x7c, 0xae, 0xd9, 0x73 };
  mixin CoInterfaces!(IWebWizardExtension);
}

abstract class PublishDropTarget {
  static Guid CLSID = { 0xcc6eeffb, 0x43f6, 0x46c5, 0x96, 0x19, 0x51, 0xd5, 0x71, 0x96, 0x7f, 0x7d };
  mixin CoInterfaces!(IDropTarget);
}

abstract class PublishingWizard {
  static Guid CLSID = { 0x6b33163c, 0x76a5, 0x4b6c, 0xbf, 0x21, 0x45, 0xde, 0x9c, 0xd5, 0x03, 0xa1 };
  mixin CoInterfaces!(IPublishingWizard);
}

abstract class InternetPrintOrdering {
  static Guid CLSID = { 0xadd36aa8, 0x751a, 0x4579, 0xa2, 0x66, 0xd6, 0x6f, 0x52, 0x02, 0xcc, 0xbb };
  mixin CoInterfaces!(IDropTarget);
}

abstract class FolderViewHost {
  static Guid CLSID = { 0x20b1cb23, 0x6968, 0x4eb9, 0xb7, 0xd4, 0xa6, 0x6d, 0x00, 0xd0, 0x7c, 0xee };
  mixin CoInterfaces!(IFolderViewHost);
}

abstract class ExplorerBrowser {
  static Guid CLSID = { 0x71f96385, 0xddd6, 0x48d3, 0xa0, 0xc1, 0xae, 0x06, 0xe8, 0xb0, 0x55, 0xfb };
  mixin CoInterfaces!(IExplorerBrowser);
}

abstract class ImageRecompress {
  static Guid CLSID = { 0x6e33091c, 0xd2f8, 0x4740, 0xb5, 0x5e, 0x2e, 0x11, 0xd1, 0x47, 0x7a, 0x2c };
  mixin CoInterfaces!(IImageRecompress);
}

abstract class TrayBandSiteService {
  static Guid CLSID = { 0xf60ad0a0, 0xe5e1, 0x45cb, 0xb5, 0x1a, 0xe1, 0x5b, 0x9f, 0x8b, 0x29, 0x34 };
  mixin CoInterfaces!(IBandSite);
}

abstract class TrayDeskBand {
  static Guid CLSID = { 0xe6442437, 0x6c68, 0x4f52, 0x94, 0xdd, 0x2c, 0xfe, 0xd2, 0x67, 0xef, 0xb9 };
  mixin CoInterfaces!(ITrayDeskBand);
}

abstract class AttachmentServices {
  static Guid CLSID = { 0x4125dd96, 0xe03a, 0x4103, 0x8f, 0x70, 0xe0, 0x59, 0x7d, 0x80, 0x3b, 0x9c };
  mixin CoInterfaces!(IAttachmentExecute);
}

abstract class DocPropShellExtension {
  static Guid CLSID = { 0x883373c3, 0xbf89, 0x11d1, 0xbe, 0x35, 0x08, 0x00, 0x36, 0xb1, 0x1a, 0x03 };
  mixin CoInterfaces!(IShellExtInit);
}

abstract class ShellItem {
  static Guid CLSID = { 0x9ac9fbe1, 0xe0a2, 0x4ad6, 0xb4, 0xee, 0xe2, 0x12, 0x01, 0x3e, 0xa9, 0x17 };
  mixin CoInterfaces!(IShellItem2);
}

abstract class NamespaceWalker {
  static Guid CLSID = { 0x72eb61e0, 0x8672, 0x4303, 0x91, 0x75, 0xf2, 0xe4, 0xc6, 0x8b, 0x2e, 0x7c };
  mixin CoInterfaces!(INamespaceWalk);
}

abstract class FileOperation {
  static Guid CLSID = { 0x3ad05575, 0x8857, 0x4850, 0x92, 0x77, 0x11, 0xb8, 0x5b, 0xdb, 0x8e, 0x09 };
  mixin CoInterfaces!(IFileOperation);
}

abstract class FileOpenDialog {
  static Guid CLSID = { 0xdc1c5a9c, 0xe88a, 0x4dde, 0xa5, 0xa1, 0x60, 0xf8, 0x2a, 0x20, 0xae, 0xf7 };
  mixin CoInterfaces!(IFileOpenDialog);
}

abstract class FileSaveDialog {
  static Guid CLSID = { 0xc0b4e2f3, 0xba21, 0x4773, 0x8d, 0xba, 0x33, 0x5e, 0xc9, 0x46, 0xeb, 0x8b };
  mixin CoInterfaces!(IFileSaveDialog);
}

abstract class KnownFolderManager {
  static Guid CLSID = { 0x4df0c730, 0xdf9d, 0x4ae3, 0x91, 0x53, 0xaa, 0x6b, 0x82, 0xe9, 0x79, 0x5a };
  mixin CoInterfaces!(IKnownFolderManager);
}

abstract class FSCopyHandler {
  static Guid CLSID = { 0xd197380a, 0x0a79, 0x4dc8, 0xa0, 0x33, 0xed, 0x88, 0x2c, 0x2f, 0xa1, 0x4b };
  mixin CoInterfaces!(IUnknown);
}

abstract class SharingConfigurationManager {
  static Guid CLSID = { 0x49f371e1, 0x8c5c, 0x4d9c, 0x9a, 0x3b, 0x54, 0xa6, 0x82, 0x7f, 0x51, 0x3c };
  mixin CoInterfaces!(ISharingConfigurationManager);
}

abstract class PreviousVersions {
  static Guid CLSID = { 0x596ab062, 0xb4d2, 0x4215, 0x9f, 0x74, 0xe9, 0x10, 0x9b, 0x0a, 0x81, 0x53 };
  mixin CoInterfaces!(IPreviousVersionsInfo);
}

abstract class NetworkConnections {
  static Guid CLSID = { 0x7007acc7, 0x3202, 0x11d1, 0xaa, 0xd2, 0x00, 0x80, 0x5f, 0xc1, 0x27, 0x0e };
  mixin CoInterfaces!(IShellFolder2);
}

abstract class NamespaceTreeControl {
  static Guid CLSID = { 0xae054212, 0x3535, 0x4430, 0x83, 0xed, 0xd5, 0x01, 0xaa, 0x66, 0x80, 0xe6 };
  mixin CoInterfaces!(INameSpaceTreeControl);
}

abstract class IENamespaceTreeControl {
  static Guid CLSID = { 0xace52d03, 0xe5cd, 0x4b20, 0x82, 0xff, 0xe7, 0x1b, 0x11, 0xbe, 0xae, 0x1d };
  mixin CoInterfaces!(INameSpaceTreeControl);
}

abstract class ScheduledTasks {
  static Guid CLSID = { 0xd6277990, 0x4c6a, 0x11cf, 0x8d, 0x87, 0x00, 0xaa, 0x00, 0x60, 0xf5, 0xbf };
  mixin CoInterfaces!(IShellFolder2);
}

abstract class ApplicationAssociationRegistration {
  static Guid CLSID = { 0x591209c7, 0x767b, 0x42b2, 0x9f, 0xba, 0x44, 0xee, 0x46, 0x15, 0xf2, 0xc7 };
  mixin CoInterfaces!(IApplicationAssociationRegistration);
}

abstract class ApplicationAssociationRegistrationUI {
  static Guid CLSID = { 0x1968106d, 0xf3b5, 0x44cf, 0x89, 0x0e, 0x11, 0x6f, 0xcb, 0x9e, 0xce, 0xf1 };
  mixin CoInterfaces!(IApplicationAssociationRegistrationUI);
}

abstract class SearchFolderItemFactory {
  static Guid CLSID = { 0x14010e02, 0xbbbd, 0x41f0, 0x88, 0xe3, 0xed, 0xa3, 0x71, 0x21, 0x65, 0x84 };
  mixin CoInterfaces!(ISearchFolderItemFactory);
}

abstract class OpenControlPanel {
  static Guid CLSID = { 0x06622d85, 0x6856, 0x4460, 0x8d, 0xe1, 0xa8, 0x19, 0x21, 0xb4, 0x1c, 0x4b };
  mixin CoInterfaces!(IOpenControlPanel);
}

abstract class ComputerInfoAdvise {
  static Guid CLSID = { 0x00a77ff7, 0xa514, 0x493e, 0xb7, 0x21, 0xcd, 0xf8, 0xcb, 0x0f, 0x5b, 0x59 };
  mixin CoInterfaces!(IComputerInfoAdvise);
}

abstract class NetworkExplorerFolder {
  static Guid CLSID = { 0xf02c1a0d, 0xbe21, 0x4350, 0x88, 0xb0, 0x73, 0x67, 0xfc, 0x96, 0xef, 0x3c };
  mixin CoInterfaces!(IShellFolder2);
}
